package kddml.Core.DataMining.ClassificationTrees;

/**
 * A manager interface for Node.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public interface NodeManager {

  /**
   * Returns true if the tree is a compound tree, i.e., a combination with and,
   * or, committee of classification trees. Returns false if the node is part of a
   * simple tree.
   *
   * @return boolean
   */
  public abstract boolean isCompoundTree();

  /**
   * Returns the size of the tree, i.e. the number of total nodes of the tree.
   *
   * @return int
   */
  public abstract int getSize();

}
