/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Core.DataMining.ClassificationTrees;

/**
 * Predicate serves as the common representation for various types of predicates.
 * A predicate can be a SimplePredicate, a BooleanPredicate or a CompoundPredicate.
 * This class is used to represent a simple predicate that consist of defining a rule in the
 * form of a simple boolean expression. The rule consist of a field, a binary
 * comparison operator, and a value.
 * A SimplePredicate can be either a SimpleSetPredicate or a SimpleComparisonPredicate,
 * depending by the comparison operator.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public abstract class SimplePredicate extends Predicate {

  /**
   * Returns the attribute name related to this predicate.
   *
   * @return String
   */
  public String getAttributeName() {
    return field;
  }
}
