/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Core.DataMining.Clustering;

import kddml.Core.DataMining.*;
import kddml.Core.*;

/**
 * A factory class that create an empty clustering model.
 * It set the distance function with an empty set of clusters.
 */
public class EmptyClusteringFactory extends ClusteringProprietaryFactory {

  /**
   * Constructor for distribution-based clustering or centroid-based clustering.
   *
   * @param f File
   * @param dd DataDictionary
   * @param ms MiningSchema
   * @param centroid_desc ClusteringDescription
   * @throws KDDMLCoreException
   */
  public EmptyClusteringFactory(java.io.File f,
                                DataDictionary dd,
                                MiningSchema ms,
                                ComparisonMeasure function,
                                ClusterDescription centroid_description)
      throws KDDMLCoreException {

    super(f, dd, ms, function, centroid_description);
  }

  public KDDMLObject newInstance() throws KDDMLCoreException {

    return super.newInstance();
  }
}
