/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */
package kddml.Core.DataMining.SequentialPatterns;

/**
 * This class represent the types of allowed gaps.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Daniele Cerra (daniele@cerra.info)
 * @version 2.0.0 alfa
 */
public class GapType {

  /**
   * TRUE attribute value
   */
  public final static String TRUE_VALUE = new String("true");

  /**
   * FALSE attribute value
   */
  public final static String FALSE_VALUE = new String("false");

  /**
   * UNKNOWN attribute value
   */
  public final static String UNKNOWN_VALUE = new String("unknown");

  /**
   * TRUE gap type
   */
  public final static GapType TRUE = new GapType(TRUE_VALUE);
  /**
   * FALSE gap type
   */
  public final static GapType FALSE = new GapType(FALSE_VALUE);
  /**
   * UNKNOWN gap type
   */
  public final static GapType UNKNOWN = new GapType(UNKNOWN_VALUE);

  private String consecutive;

  protected GapType(String consecutive) {
    this.consecutive = consecutive;
  }

  public String getConsecutive(){ return this.consecutive; }

  public boolean equals(GapType g){
    return this.getConsecutive().equals(g.getConsecutive());
  }

  public String toString(){ return this.consecutive; }
}
