/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */
package kddml.Core.DataMining.SequentialPatterns;

import java.util.*;

/**
 * This utility class contains methods used inside this package
 * for building sets from sequences.
 *
* <p>Title: KDDML</p>
* <p>Description: Knowledge Discovery in Database Environment</p>
* <p>Copyright: Copyright (c) 2004</p>
* <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
* @author Daniele Cerra (daniele@cerra.info)
* @version 2.0.0 alfa
 */
final class USequenceElementBuilder {

  /**
   * Calcola gli elementi delle sequenze dato in ingresso un insieme di sequenze.
   */
  protected static TreeSet compute(TreeSet sequences) {
    Comparator comp = new CompareSequenceElements();
    TreeSet ris = new TreeSet(comp);
    Iterator iter = sequences.iterator();

    while(iter.hasNext()) {
     SequenceManager sequence = (SequenceManager) iter.next();
     Iterator el_iter = sequence.getElements();

     while(el_iter.hasNext()){
       SequenceElementManager el = (SequenceElementManager) el_iter.next();
       ris.add(el);
       if( el_iter.hasNext() ) el_iter.next(); //skip delimiter
     }

   }

    return ris;
  }

}
