/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Core.DataSources;

import java.util.Collection;

/**
 * This class contains an enumeration of attribute types.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public class AttributeType extends AttributeTypeEnum {

  public final static AttributeType NUMERIC = new AttributeType("numeric", "integer or real value");

  public final static AttributeType NOMINAL = new AttributeType("nominal", "enumerated attribute");

  public final static AttributeType STRING = new AttributeType("string", "string");

  private String description;

  private AttributeType(String name, String description) {
    super(name);
    enumList.put(name, this);
    this.description = description;
  }

  public AttributeType(String name) {
    super(name);
  }

  public static AttributeType[] list() {

    Collection enums = enumList.values();
    Object objects[] = enums.toArray();
    AttributeType values2[] = new AttributeType[enumList.size()];
    System.arraycopy(((Object) (objects)), 0, values2, 0, enumList.size());

    return values2;
  }

  public String getDescription() {
    return description;
  }
}
