/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Core.DataSources;

/**
 * This utility class contains methods and variables used inside this package.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
final class SpaceNames {

  protected final static String IO_ERROR_MESSAGE = "I/O error found accessing data repository.";

  protected final static String SCHEMA_EXTENSION = ".xml";
  protected final static String DATA_EXTENSION = ".csv";

  protected final static String SEPARATOR = ",";
  protected final static String MISSING = "?";

  protected final static String ELEMENT_KDDML_OBJECT = "KDDML_OBJECT";
  protected final static String ELEMENT_KDDML_TABLE = "KDDML_TABLE";
  protected final static String ELEMENT_SCHEMA = "SCHEMA";
  protected final static String ELEMENT_PPSCHEMA = "PPSCHEMA";
  protected final static String ELEMENT_HISTORY = "HISTORY";
  protected final static String ELEMENT_PREPROCESSING_TASK = "PREPROCESSING_TASK";
  protected final static String ELEMENT_OPERATION = "operation_name";
  protected final static String ELEMENT_DESCRIPTION= "description";


  protected final static String ATTRIBUTE_DATA_FILE = "data_file";
  protected final static String ATTRIBUTE_PPDATA_FILE = "pp_data_file";
  protected final static String ATTRIBUTE_RELATION_NAME = "logical_name";
  protected final static String ATTRIBUTE_NUM_INSTANCES = "number_of_instances";
  protected final static String ATTRIBUTE_NUM_ATTRIBUTES = "number_of_attributes";

  protected final static String ELEMENT_ATTRIBUTE = "ATTRIBUTE";
  protected final static String ATTRIBUTE_TYPE = "type";
  protected final static String ATTRIBUTE_NAME = "name";
  protected final static String ATTRIBUTE_MISSED = "number_of_missed_values";
  protected final static String ATTRIBUTE_MISSED_PERC = "number_of_missed_values_perc";
  protected final static String ATTRIBUTE_TAXONOMY = "taxonomy_name";

  protected final static String ELEMENT_NUMERIC_DESCRIPTION = "NUMERIC_DESCRIPTION";
  protected final static String ATTRIBUTE_MEAN = "mean";
  protected final static String ATTRIBUTE_VARIANCE = "variance";
  protected final static String ATTRIBUTE_SUM = "sum";
  protected final static String ATTRIBUTE_SUMQ = "sumSq";
  protected final static String ATTRIBUTE_MIN = "min";
  protected final static String ATTRIBUTE_MAX = "max";

  protected final static String ELEMENT_STRING_DESCRIPTION = "STRING_DESCRIPTION";

  protected final static String ELEMENT_NOMINAL_DESCRIPTION = "NOMINAL_DESCRIPTION";
  protected final static String ATTRIBUTE_CARD = "cardinality";
  protected final static String ATTRIBUTE_CARD_PERC = "cardinality_perc";
  protected final static String ELEMENT_VALUE = "VALUE";
  protected final static String ATTRIBUTE_VALUE = "value";
  protected final static String ATTRIBUTE_NUM_VALUES = "number_of_values";
}
