/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Core;

/**
 * The interface KDDMLCoreErrorCodes defines the error codes to be used in the kddml Core
 * package.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public interface KDDMLCoreErrorCodes {

  public final static int DOM_PARSER_ERROR = 0;

  public final static int NULL_ARGUMENT = 1;

  public final static int STATISTIC_TYPE_CASTING_ERROR = 2;

  public final static int JDBC_CONNECTION_FAILURE = 3;

  public final static int IO_ERROR = 4;

  public final static int INVALID_PMML_DOCUMENT = 5;

  public final static int OBJECT_EXIST_IN_REPOSITORY = 6;

  public final static int EMPTY_OBJECT = 7;

  public final static int OBJECT_NOT_EXIST_IN_REPOSITORY = 8;

  public final static int INVALID_SETTINGS = 9;

  public final static int OUT_OF_MEMORY = 10;

  public final static int MALFORMED_CONDITION = 11;

  public final static int MALFORMED_EXPRESSION = 12;

  public final static int NO_DTD_FOUND = 13;

  public final static int NOT_YET_IMPLEMENTED = 14;

  public final static int XSL_ERROR = 15;

  public final static int HTML_TRANSFORMATION_ERROR = 16;

  public final static int UNSUPPORTED_CONDITION_OPERATOR = 17;

  public final static int INVALID_MODEL = 18;
}
