/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Core;

import java.io.Serializable;
import java.util.*;

public abstract class KDDMLObjectTypeEnum implements Serializable {

    private String value;
    private int ID;

    protected static Hashtable enumList = new Hashtable();

    protected KDDMLObjectTypeEnum(String value)
    {
        if(value != null)
        {
            this.value = new String(value);
        }
    }

    protected KDDMLObjectTypeEnum()
    {
    }

    protected int getID()
    {
        return ID;
    }

    protected void setID(int id)
    {
        ID = id;
    }

    public String getName()
    {
        return value;
    }

    public boolean equals(Object obj)
    {
        if(obj == null)
        {
            return false;
        }
        if(0 != getClass().getName().compareTo(obj.getClass().getName()))
        {
            return false;
        }
        KDDMLObjectTypeEnum obj2 = (KDDMLObjectTypeEnum)obj;
        if(0 != value.compareTo(obj2.getName()))
        {
            return false;
        } else
        {
            return ID == obj2.getID();
        }
    }
}
