/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Core.ProprietaryElement.Condition;

import weka.core.*;
import kddml.Core.ProprietaryElement.*;

/**
 * This class represent a generic condition element.
 */
public final class BooleanCondition extends Condition {

  boolean value;

  protected BooleanCondition(boolean b) {
    super();
    value = b;
  }

  public boolean evalCond(weka.core.Instance instance, weka.core.Instance instance2)
      throws XMLSpecialElementException {
    return value;
  }

  /**
   * Check the compatibility of this base condition.
   * Throws an exception if terms type are illegal.
   *
   * @throws XMLSpecialElementException
   */
  public void checkConditionValidity() throws kddml.Core.ProprietaryElement.XMLSpecialElementException {
  }

  public String toString() {
    if (value)
      return "true";
    else
      return "false";
  }
}
