/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Core.ProprietaryElement;

import org.w3c.dom.*;
import kddml.Core.*;
import kddml.Core.ProprietaryElement.*;

/**
 * The XML class denotes arguments that are generic XML elements to be evaluated
 * directly by the operator.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public class XML extends XMLSpecialElement {

  Element elem;

  /**
   * Constructor give the XML DOM element.
   *
   * @param xml_element Element
   */
  public XML(Element xml_element) {
    elem = xml_element;
  }

  /**
   * It returns the type of the object.
   *
   * @return KDDMLObjectType the type of this object
   */
  public kddml.Core.KDDMLObjectType getType() {
    return kddml.Core.KDDMLObjectType.XML;
  }

  /**
   * Returns the XML DOM element. This element is evaluated directly by the
   * operator.
   *
   * @return Element
   */
  public Element getElement() {
    return elem;
  }
}
