/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Interpreter;

import java.io.*;
import java.net.*;
import java.util.zip.*;

public class IOUtility
{

  public static BufferedReader getReader(String name) throws IOException
  {
    InputStream is;

    try {
      URL url = new URL(name);
      is =  url.openStream();
    }
    catch(MalformedURLException e)
    {
      is = new FileInputStream( name );
    }

    if( name.endsWith(".gz") )
      is = new GZIPInputStream(is);

    return new BufferedReader( new InputStreamReader(is, "UTF-8") );

  }

  public static InputStream getInputStream(String name) throws IOException
  {
    InputStream is;

    try {
      URL url = new URL(name);
      is =  url.openStream();
    }
    catch(MalformedURLException e)
    {
      is = new FileInputStream( name );
    }

    if( name.endsWith(".gz") )
      is = new GZIPInputStream(is);

    return is;

  }
}
