/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Interpreter;

public interface InterpreterChecker {

  /**
   * Testa se la query e' staticamente valida.
   * Controlla:
   * - che il valore dei parametri di ogni operatore sia del tipo atteso
   * - che ogni algoritmo sia implementato
   * - che ogni parametro di ogni algoritmo sia del tipo atteso
   * - testing di ogni connessione con DBMS specificate nella query
   * - che ogni condition sia supportata e con i valori per le condizioni base attesi
   *
   * @return boolean
   */
  public void validateQuery() throws KDDMLInterpreterException;
}
