/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Interpreter;

/**
 * Eccezione sollevata dal query executor quando la query in ingresso non e' una
 * KDDML query valida o alcuni parametri sono illegali.
 */

public class InvalidKDDMLQueryException extends KDDMLInterpreterException {

  /**
   * Metodo costruttore; crea un'istanza della classe inizializzando i parametri.
   * Comprende il caso di errore generico.
   *
   * @param msg_gui messaggio da visualizzare nell'interfaccia grafica.
   */
  public InvalidKDDMLQueryException(String msg1, String msg2) {
    super(msg1, msg2);
  }
}
