/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Interpreter;

/**
 * Eccezione sollevata dal query executor quando viene riscontrato un errore di tipo.
 */

public class NotYetImplementedException extends KDDMLInterpreterException {

  private final static String[] list = {};

  /**
   * Metodo costruttore; crea un'istanza della classe inizializzando i parametri.
   * Comprende il caso di errore generico.
   *
   * @param msg_gui messaggio da visualizzare nell'interfaccia grafica.
   */
  public NotYetImplementedException(String operator_name) {
    super("Operator <"+operator_name+"> not yet implemented!", null);
  }

  /**
   * Restituisce la lista degli operatori attualmente implementati.
   *
   * @return String[]
   */
  public static boolean isNotImplemented(String op) {
    for (int i=0; i<list.length; i++)
      if (op.equals(list[i]))
        return true;
    return false;
  }

  public static String[] getList() {
    return list;
  }
}
