/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.KDDMLGui;

import java.io.File;

/**
 * HTML browse opening.
 */

public final class BrowserManager {

  public final static void openBrowser(File html_file)
      throws BrowserException {

    String cmd = "explorer "+html_file;
    System.out.println("Apertura del browser > "+cmd);
    try {
      Runtime.getRuntime().exec(cmd);
    }
    catch (Exception ec) {
      cmd = "netscape "+html_file.getAbsolutePath();
      try {
        Runtime.getRuntime().exec(cmd);
      }
      catch (Exception ecc) {
        cmd = "mozilla "+html_file.getAbsolutePath();
        try {
          Runtime.getRuntime().exec(cmd);
        }
        catch (Exception eccc) {
          throw new BrowserException(html_file.getAbsolutePath());
        }
      }
    }
  }
}
