/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.KDDMLGui;

import com.ibm.xml.parser.*;

/**
 * DTD Parser.
 */

final public class DTDParser {

  public static DTD parse(String path,
                          GUIErrorListenerDTD listener) throws java.io.IOException {
    DTD dtd = null;
    // creazione dell'elemento m_dtd per le query KDDML
    Parser pc = new Parser(path, listener, null);
    dtd = pc.readDTDStream(pc.getInputStream(path,
                                             null,
                                             Stderr.file2URL(path).toString()));
    // Se ci sono errori li visualizza nella jtextArea
    if (pc.getNumberOfErrors() != 0 || pc.getNumberOfWarnings() != 0) {
      return null;
    }
    return dtd;
  }
}
