/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.KDDMLGui;

import java.io.*;
import java.util.Vector;

class KDDMLFileFilter extends javax.swing.filechooser.FileFilter {

  // estenzione da utilizzare
  private Vector extensions;

  /**
   * Costruttore.
   *
   * @param est il filtro all'estenzione da applicare
   */
  protected KDDMLFileFilter() {
    extensions = new Vector();
  }

  protected void addExtension(String extension) {
    extensions.add(extension);
  }

  /**
   * Filtra i files contenuti nella directory in ingresso che hanno estenzione .xml
   *
   * @param dir la directory contenente il file
   * @param name il file in ingresso
   * @return true se e solo se il file puo' essere incluso nella lista
   */

  public boolean accept(File name) {
    // accetta name se e' una directory
    if (name.isDirectory())
      return true;
    for (int i=0; i< extensions.size(); i++)
      if (name.getName().toLowerCase().endsWith((String) extensions.get(i)))
        return true;
    return false;
  }

  public String getDescription() {
    return "xml files";
  }
}
