/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.KDDMLGui;

import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.DocumentType;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Attr;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.border.*;
import javax.swing.filechooser.*;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.awt.Point;
import kddml.Interpreter.*;
import kddml.Core.XMLUtility;
import se.sics.jasper.*;
import com.ibm.xml.parser.NonRecursivePreorderTreeTraversal;
import com.ibm.xml.parser.*;
import kddml.Core.*;
import kddml.Core.DataSources.*;
import kddml.Core.DataMining.AssociationRules.*;
import kddml.Core.DataMining.ClassificationTrees.*;
import kddml.Core.DataMining.Clustering.*;
import kddml.Core.DataMining.SequentialPatterns.*;
import kddml.Core.DataMining.Taxonomy.*;


class TreeNode {
  String etichetta;
  Element el;

  public TreeNode(String s, Element e) {
    etichetta = s;
    el = e;
  }

  public String toString() {
    return this.etichetta;
  }
}

/**
 * Classe che implementa le funzionalita' dell'interfaccia utente, con le quali e' possibile:</BR>
 * - creare, aprire, salvare, ed eseguire una query</BR>
 * - visualizzare i risultati ottenuti in precedenza</BR>
 * - visualizzare le ApiDocs del prototipo</BR>
 */

public class GUI extends JFrame {

  static final Color BACKGROUND = SystemColor.controlHighlight;

  static final String S_EOC = "*** END DICHIARATION ***";
  static final String S_TEXT = "**** qualsiasi testo ****";
  DTD m_dtd;
  Hashtable m_hash;
  Vector m_allel;
  Element m_root;
  Element tmp_m_root;
  static Element query;
  static Document doc_query;
  Element nodoCorrente;
  Element currEl = null;
  JFrame File_Frame;
  JPanel contentPane;
  JPanel contentPane2;
  JPanel contentPane3;
  JPanel contentPane4;
  JPanel contentPane5;
  JPanel contentPane6;
  JPanel contentPane7;
  JScrollPane jScrollPane5;
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JTabbedPane jTabbedPane2 = new JTabbedPane();
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenu menuOptions = new JMenu();
  JMenu menuBrowser_View = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenuItem menuOpenQuery = new JMenuItem();
  JMenuItem menuCreateQuery = new JMenuItem();
  JMenuItem menuSaveQuery = new JMenuItem();
  //JMenuItem menuDBMS = new JMenuItem();
  JMenuItem menuTable = new JMenuItem();
  JMenuItem menuPPTable = new JMenuItem();
  JMenuItem menuAssociationModel = new JMenuItem();
  JMenuItem menuSequenceModel = new JMenuItem();
  JMenuItem menuAlberi = new JMenuItem();
  JMenuItem menuCluster = new JMenuItem();

  JMenuItem menuQuery = new JMenuItem();
  BorderLayout borderLayout2 = new BorderLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  BorderLayout borderLayout5 = new BorderLayout();
  BorderLayout borderLayout6 = new BorderLayout();
  BorderLayout borderLayout7 = new BorderLayout();

  JSplitPane jSplitPane1 = new JSplitPane();
  JSplitPane jSplitPane2 = new JSplitPane();
  TitledBorder titledBorder1;
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  static JTextArea jTextArea3 = new JTextArea();
  Border border1;
  TitledBorder titledBorder2;
  Border border2;
  TitledBorder titledBorder3;
  Border border3;
  TitledBorder titledBorder4;
  JEditorPane jEditorPane1 = new JEditorPane();
  DefaultListModel listModel = new DefaultListModel();
  boolean trovato = false;
  JList jList1 = new JList(listModel);
  JButton btok = new JButton("Insert");
  JPanel jLabels = new JPanel();
  JPanel jFields = new JPanel();
  JButton btok2 = new JButton("OK");
  JButton btok3 = new JButton("Execute");
  JButton arff_button = new JButton("Select ARFF");
  JButton btokmodify = new JButton("Modify Attributes");
  JButton btokchange = new JButton("Change Element");
  JButton btok4 = new JButton("Execute");
  int posizione = 0;
  JLabel[] labels = new JLabel[15];
  JComponent[] fields = new JComponent[15];
  JFileChooser openQuery = new JFileChooser(KDDMLObjectType.KDD_QUERY.getRepositoryPath());
  JFileChooser openARFF = new JFileChooser(KDDMLObjectType.INTERNAL_TABLE.getRepositoryPath());
  ARFFPathSplitter arff_splitter;
  JFileChooser openBrowser_association = new JFileChooser(KDDMLObjectType.PMML_ASSOCIATION_MODEL.getRepositoryPath());
  JFileChooser openBrowser_sequence = new JFileChooser(KDDMLObjectType.PMML_SEQUENCE_MODEL.getRepositoryPath());
  JFileChooser openBrowser_alberi = new JFileChooser(KDDMLObjectType.PMML_CLASSIFICATION_MODEL.getRepositoryPath());
  JFileChooser openBrowser_clusters = new JFileChooser(KDDMLObjectType.PMML_CLUSTERING_MODEL.getRepositoryPath());
  JFileChooser openBrowser_table = new JFileChooser(KDDMLObjectType.INTERNAL_TABLE.getRepositoryPath());
  JFileChooser openBrowser_PPtable = new JFileChooser(KDDMLObjectType.INTERNAL_PPTABLE.getRepositoryPath());
  JComboBox jComboBox;
  String commento = new String();
  GUIErrorListenerDTD parserListener;
  int stato = 0;
  // La variabile stato puo' assumere i seguenti valori:
  //  - 0 : si puo' inserire un elemento
  //  - 1 : si possono inserire attributi
  //  - 2 : la query e' terminata
  //  - 3 : il documento aperto non e' una kdd-query
  //  - 4 : modifica degli attributi di un elemento
  //  - 5 : cambio di un elemento
  //  - 6 : tag <ALGORITHM> incompatibile
  Element changing;
  Element[] listaFigli = new Element[10];
  Element[] tmp_listaFigli = new Element[10];
  JTree tree = new JTree(new DefaultMutableTreeNode("KDDML_OBJECT"));

  SICStus sp;
  boolean benformato = true;
  BorderLayout borderLayout1 = new BorderLayout();
  String cond_type = null;
  int cond_el = 1;

  // finestra di dialogo per il settaggio dei parametri del DBMS
  //private DBMSConnectionFrame DBMSd;

  /**
   * Crea un'istanza della classe inizializzando opportunamente tutte le componenti dell'interfaccia
   *
   */
  public GUI(String sicstus_path) {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    if (sicstus_path != null) {
      try {
        sp = new SICStus(null, null);
        //System.out.println(System.getProperty("java.library.path"));
        sp = new SICStus(null, sicstus_path);
      }
      catch (java.lang.UnsatisfiedLinkError e) {
        // SICSTUS PROLOG NON INSTALLATO
        System.out.println(
            "---------------------------------------------------------------------------");
        System.out.println(
            "Attention please: Sictus prolog kernel is not installed");
        System.out.println("If you want to use prolog operator, make sure that sictus is correctly installed");
        System.out.println(
            "---------------------------------------------------------------------------");
      }
      catch (Exception e) {
        // SICSTUS PROLOG NON INSTALLATO
        System.out.println(
            "---------------------------------------------------------------------------");
        System.out.println(
            "Attention please: Sictus prolog kernel is not installed.");
        System.out.println("If you want to use prolog operator, make sure that sictus is correctly installed.");
        System.out.println(
            "---------------------------------------------------------------------------");
        e.printStackTrace();
      }
    }
    // SICSTUS PROLOG INSTALLATO CORRETTAMENTE
    try {
      jbInit();
    }
    catch (Exception ecc2) {
      System.out.println("Eccezione: " + ecc2);
    }
  }

  //Inizializzazione delle componenti
  private void jbInit() throws Exception {
    File_Frame = new JFrame();
    //DBMSd = new DBMSConnectionFrame(this);
    contentPane = (JPanel)this.getContentPane();
    contentPane2 = new JPanel();
    contentPane3 = new JPanel();
    contentPane3.setLayout(borderLayout3);
    contentPane3.add(jLabels, BorderLayout.WEST);
    contentPane3.add(jFields, BorderLayout.CENTER);
    contentPane3.add(btok2, BorderLayout.SOUTH);
    contentPane4 = new JPanel();
    contentPane5 = new JPanel();
    contentPane6 = new JPanel();
    contentPane7 = new JPanel();
    contentPane5.setLayout(borderLayout5);
    contentPane6.setLayout(borderLayout6);
    jScrollPane5 = new JScrollPane(tree);
    contentPane4.setLayout(borderLayout4);
    contentPane4.add(jTabbedPane1, BorderLayout.CENTER);
    border1 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(142, 142, 142));
    border2 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(142, 142, 142));
    border3 = new EtchedBorder(EtchedBorder.RAISED, Color.white,
                               new Color(142, 142, 142));
    titledBorder4 = new TitledBorder(border3, "Messages", TitledBorder.TOP,
                                     TitledBorder.LEFT, null,
                                     Color.black);
    contentPane.setLayout(borderLayout1);
    jLabels.setLayout(new BoxLayout(jLabels, BoxLayout.Y_AXIS));
    jFields.setLayout(new BoxLayout(jFields, BoxLayout.Y_AXIS));
    KDDMLFileFilter filter = new KDDMLFileFilter();
    filter.addExtension(".xml");

    openQuery.setFileFilter(filter);
    openQuery.setDialogTitle("KDD Query Repository Selection");
    openQuery.setAcceptAllFileFilterUsed(false);

    KDDMLFileFilter filter_arff = new KDDMLFileFilter();
    filter_arff.addExtension(".arff");
    openARFF.setFileFilter(filter_arff);
    openARFF.setDialogTitle("ARFF Selection");
    openARFF.setAcceptAllFileFilterUsed(false);

    openBrowser_association.setFileFilter(filter);
    openBrowser_association.setDialogTitle("Association Rules Repository Selection");
    openBrowser_association.setAcceptAllFileFilterUsed(false);

    openBrowser_sequence.setFileFilter(filter);
    openBrowser_sequence.setDialogTitle("Sequence Repository Selection");
    openBrowser_sequence.setAcceptAllFileFilterUsed(false);

    openBrowser_alberi.setFileFilter(filter);
    openBrowser_alberi.setDialogTitle("Association Tree Repository Selection");
    openBrowser_alberi.setAcceptAllFileFilterUsed(false);

    openBrowser_clusters.setFileFilter(filter);
    openBrowser_clusters.setDialogTitle("Cluster Repository Selection");
    openBrowser_clusters.setAcceptAllFileFilterUsed(false);

    openBrowser_table.setFileFilter(filter);
    openBrowser_table.setDialogTitle("Data Source Repository Selection");
    openBrowser_table.setAcceptAllFileFilterUsed(false);

    openBrowser_PPtable.setFileFilter(filter);
    openBrowser_PPtable.setDialogTitle("Preprocessing Data Source Repository Selection");
    openBrowser_PPtable.setAcceptAllFileFilterUsed(false);

    this.setSize(new Dimension(800, 600));
    this.setTitle("KDDML : a markup language for KDD");
    menuFile.setText("File");
    menuOptions.setText("Options");
    menuBrowser_View.setText("Browser View");
    menuCreateQuery.setText("Create");
    menuOpenQuery.setText("Open");
    menuSaveQuery.setText("Save");
    menuFileExit.setText("Exit");
    //menuDBMS.setText("DBMS Connection");
    menuTable.setText("KDDML Data Sources");
    menuPPTable.setText("Preprocessing Data Sources");
    menuAssociationModel.setText("Association Model");
    menuSequenceModel.setText("Sequence Model");
    menuAlberi.setText("Classification Trees");
    menuCluster.setText("Clusters");
    tree.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
    tree.addTreeSelectionListener(new TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)
            tree.getLastSelectedPathComponent();

        if (node == null)
          return;

        TreeNode nodeInfo = (TreeNode) node.getUserObject();
        currEl = nodeInfo.el;
      }
    }
    );

    menuFileExit.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuOpenQuery.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        openQuery_actionPerformed(e);
      }
    });

    menuCreateQuery.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        createQuery_actionPerformed(e);
      }
    });

    menuSaveQuery.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        saveQuery_actionPerformed(e);
      }
    });

    /*menuDBMS.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        DBMSConnection(e);
      }
    });*/

    menuTable.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        table_actionPerformed(e);
      }
    });

    menuPPTable.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        PPtable_actionPerformed(e);
      }
    });

    menuAssociationModel.addActionListener(new ActionListener() {

     public void actionPerformed(ActionEvent e) {
       association_actionPerformed(e);
     }
   });

    menuSequenceModel.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        sequence_actionPerformed(e);
      }
    });

    menuAlberi.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        alberi_actionPerformed(e);
      }
    });

    menuCluster.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent e) {
        cluster_actionPerformed(e);
      }
    });

    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setDividerSize(2);
    jSplitPane2.setDividerSize(2);
    jScrollPane3.setBorder(titledBorder4);
    menuFile.add(menuCreateQuery);
    menuFile.add(menuOpenQuery);
    menuFile.add(menuSaveQuery);
    menuFile.add(menuFileExit);
    //menuOptions.add(menuDBMS);
    menuBrowser_View.add(menuTable);
    menuBrowser_View.add(menuPPTable);
    menuBrowser_View.add(menuAssociationModel);
    menuBrowser_View.add(menuSequenceModel);
    menuBrowser_View.add(menuAlberi);
    menuBrowser_View.add(menuCluster);
    menuBar1.add(menuFile);
    menuBar1.add(menuOptions);
    menuBar1.add(menuBrowser_View);
    contentPane2.setLayout(borderLayout2);
    contentPane7.setLayout(borderLayout7);
    contentPane2.add(jScrollPane2, BorderLayout.CENTER);
    contentPane2.add(btok, BorderLayout.SOUTH);
    contentPane.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(jSplitPane2, JSplitPane.TOP);
    jSplitPane2.add(contentPane4, JSplitPane.LEFT);
    jSplitPane2.add(jTabbedPane2, JSplitPane.RIGHT);
    contentPane5.add(jScrollPane1, BorderLayout.CENTER);
    contentPane5.add(btok3, BorderLayout.SOUTH);
    contentPane6.add(jScrollPane5, BorderLayout.CENTER);
    contentPane6.add(contentPane7, BorderLayout.SOUTH);
    contentPane7.add(btokchange, BorderLayout.WEST);
    contentPane7.add(btokmodify, BorderLayout.EAST);
    jTabbedPane1.addTab("XML View", contentPane5);
    jTabbedPane1.addTab("Tree View", contentPane6);
    jTabbedPane2.addTab("Allowable Elements", contentPane2);
    jTabbedPane2.addTab("Attributes", contentPane3);
    jScrollPane2.getViewport().add(jList1, null);
    jSplitPane1.add(jScrollPane3, JSplitPane.BOTTOM);
    jScrollPane3.getViewport().add(jTextArea3, null);
    jScrollPane3.getViewport().addChangeListener(new ChangeListener() {
      private int lastHeight;
      public void stateChanged(ChangeEvent e) {
        JViewport vp = (JViewport) e.getSource();
        int h = vp.getViewSize().height;
        if (h != lastHeight) {
          lastHeight = h;
          int x = h - vp.getExtentSize().height;
          vp.setViewPosition(new Point(0, x));
        }
      }
    });
    jScrollPane1.getViewport().add(jTextArea1, null);
    jTextArea1.setEditable(false);
    jTextArea3.setEditable(false);
    this.setJMenuBar(menuBar1);
    jSplitPane1.setDividerLocation(400);
    jSplitPane2.setDividerLocation(400);
    btok.addActionListener(new InsertListener());
    btok2.addActionListener(new OKListener());
    btok3.addActionListener(new SubmitListener());
    btok4.addActionListener(new SubmitListener());
    /************************************************************/
    btokchange.addActionListener(new ChListener());
    /************************************************************/
    btokmodify.addActionListener(new ModifyListener());
    arff_button.addActionListener(new ARFFListener());
    labels[0] = new JLabel("No element selected");
    jLabels.add(labels[0]);
    jTextArea3.setAutoscrolls(true);
    parserListener = new GUIErrorListenerDTD(jTextArea3);
  }


  /**
   * Metodo per la chiusura dell'interfaccia;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' FILE.
   */
  public void fileExit_actionPerformed(ActionEvent e) {
    // rimozione dei files temporanei creati
    kddml.Interpreter.QueryExecutor.removeTmpResults();
    HTMLCleanerUtility.removeHTMLResults();
    System.exit(0);
  }

  /**
   * Metodo per l'apertura di un query esistente;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' FILE.
   *
   */
  public void openQuery_actionPerformed(ActionEvent e) {
    int returnVal = openQuery.showOpenDialog(File_Frame);
    benformato = true;
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openQuery.getSelectedFile();
      Element root = null;
      query = null;
      KDDQuery q = null;
      try {
        q = new kddml.Core.KDDQuery(file);
      }
      catch (KDDMLCoreException ex) {
        jTextArea3.append(Messages.line);
        jTextArea3.append(ex.getErrorMessage() + "\n");
        benformato = false;
        stato = 3;
        return;
      }
      catch (FileNotFoundException ex2) {
        jTextArea3.append(Messages.line);
        jTextArea3.append("Query < "+file.getAbsolutePath()+" > not found!\n");
        benformato = false;
        stato = 3;
        return;
      }
      doc_query = q.getDocumentRoot();
      root = doc_query.getDocumentElement();
      query = (Element) root.getElementsByTagName("KDD_QUERY").item(0);
      if (benformato) {
        m_root = root;
        out();
        stato = 2;
        // controlla la compatibilita' dei parametri
        //try {
          QueryExecutor executor = new QueryExecutor(doc_query);
          jTextArea3.append(Messages.line);

          jTextArea3.append("Parsing ...     OK\n");
          //executor.validateQuery();
          //jTextArea3.append("Validation ...     OK\n");

          jTextArea3.append("The file " + file.getAbsolutePath() +
                            " contains a valid KDD_QUERY." + "\n");
          jTextArea3.append("Click on < Execute > to run it.\n");
        //}
        /*catch(KDDMLInterpreterException ecc) {
          jTextArea3.append(Messages.line);
          jTextArea3.append("The query created is not valid: "+ecc.getErrorMessage()+"\n");
          stato = 6;
        }*/
      }
    }
    else {
      jTextArea3.append(
          "------------------------------------------------------\n");
      jTextArea3.append("Open command cancelled by user." + "\n");
    }
  }

  /**
   * Metodo per l'inserimento dei parametri di connessione per l'accesso ad un database.
   */
  /*public void DBMSConnection(ActionEvent e) {
    DBMSd.pack();
    DBMSd.setVisible(true);
    String s1 = DBMSd.getServer();
    String s2 = DBMSd.getUser();
    String s3 = DBMSd.getPassword();
   // String s4 = DBMSd.getDB();
    short s5 = DBMSd.getDBMS();
    if (s1 != null & s2 != null & s3 != null) {
      // salvataggio dei parametri introdotti...
      //DBMSConnectionParameters.setParam(s5, s1, s2, s3, s4);

      // crea un oggetto JDBCConnection
      JDBCConnection conn;
      if (s5 == DBMSConnectionFrame.SQL_SERVER)
        conn = new JDBCSQLServerConnection(s2, s3, s1);
      else
        conn = new JDBCOracleConnection(s2, s3);
      QueryExecutor.setJDBCConnection(conn);

    }
  }*/

  /**
   * Metodo per la visualizzazione mediante browser di una tabella;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' Browser View.
   */
  public void table_actionPerformed(ActionEvent e) {
    int returnVal = openBrowser_table.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_table.getSelectedFile();
      try {
        InternalTableRepositoryFactory fact = new InternalTableRepositoryFactory(file);

        InternalTable t = (InternalTable) fact.newInstance();
        t.saveHTML();
        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }
  }

  /**
   * Metodo per la visualizzazione mediante browser di una tabella di preprocessing;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' Browser View.
   */
  public void PPtable_actionPerformed(ActionEvent e) {
    int returnVal = openBrowser_PPtable.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_PPtable.getSelectedFile();
      try {
        PPInternalTableRepositoryFactory fact = new PPInternalTableRepositoryFactory(file);

        PPInternalTable t = (PPInternalTable) fact.newInstance();
        t.saveHTML();
        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }
  }


  /**
   * Metodo per la visualizzazione mediante browser di un insieme di regole esistente;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' Browser View.
   */
  public void association_actionPerformed(ActionEvent e) {
    int returnVal = openBrowser_association.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_association.getSelectedFile();
      try {
        AssociationRepositoryFactory fact = new AssociationRepositoryFactory(file);

        AssociationModel t = (AssociationModel) fact.newInstance();
        t.saveHTML();

        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }
  }


  /**
   * Metodo per la visualizzazione mediante browser di un insieme di regole esistente; e' invocato quando
   * e' scelta la corrispondente opzione nel menu' Browser View.
   *
   */
  public void sequence_actionPerformed(ActionEvent e) {

    int returnVal = openBrowser_sequence.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_sequence.getSelectedFile();
      try {
        SequenceRepositoryFactory fact = new SequenceRepositoryFactory(file);

        SequenceModel t = (SequenceModel) fact.newInstance();
        t.saveHTML();

        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }

  }

  /**
   * Metodo per la visualizzazione mediante browser di un albero di classificazione esistente;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' Browser View.
   */
  public void alberi_actionPerformed(ActionEvent e) {
    int returnVal = openBrowser_alberi.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_alberi.getSelectedFile();
      try {
        ClassificationRepositoryFactory fact = new ClassificationRepositoryFactory(file);

        TreeModel t = (TreeModel) fact.newInstance();
        t.saveHTML();

        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }
  }

  /**
   * Metodo per la visualizzazione mediante browser di un insieme di clusters esistente;
   * e' invocato quando e' scelta la corrispondente opzione nel menu' Browser View.
   *
   */
  public void cluster_actionPerformed(ActionEvent e) {
    int returnVal = openBrowser_clusters.showOpenDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
      File file = openBrowser_clusters.getSelectedFile();
      try {
        ClusteringRepositoryFactory fact = new ClusteringRepositoryFactory(file);

        ClusteringModel t = (ClusteringModel) fact.newInstance();
        t.saveHTML();

        // apertura del browser per la successiva visualizzazione
        String s = t.getPhysicalObject().getAbsolutePath() + ".html";
        BrowserManager.openBrowser(new File(s));

      }
      catch(KDDMLCoreException ecc) {
        jTextArea3.append("Error found during HTML code generation:\n");
        jTextArea3.append(ecc.getErrorMessage());
        System.out.println(ecc.getDetailErrorMessage());
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
      }
    }
  }

  /**
   * Metodo per la creazione di una nuova KDD query; e' invocato quando e' scelta la corrispondente
   * opzione nel menu' FILE.
   *
   */

  public void createQuery_actionPerformed(ActionEvent e) {
    jTextArea3.append(Messages.line);
    jTextArea3.append("Creating a new query. \n");

    //Crea l'albero DOM con radice KDDML_OBJECT
    doc_query = XMLUtility.initializeDocument("KDDML_OBJECT");

    Element el = XMLUtility.doc.createElement("KDD_QUERY");
    doc_query.getDocumentElement().appendChild(el);

    m_root = doc_query.getDocumentElement();
    query = el;
    nodoCorrente = query;
    stato = 1;
    if (fields[0] != null)
      jFields.remove(fields[0]);
    for (int i = 1; i < posizione; i++) {
      if (labels[i] != null)
        jLabels.remove(labels[i]);
      if (fields[i] != null)
        jFields.remove(fields[i]);
    }
    inserisciAttributi(nodoCorrente);
    out();
  }


  /**
   * Metodo per il salvataggio della KDD query corrente; e' invocato quando e' scelta la corrispondente
   * opzione nel menu' FILE.
   *
   */

  public void saveQuery_actionPerformed(ActionEvent e) {
    int returnVal = openQuery.showSaveDialog(File_Frame);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
    File file = null;
      try {
        file = openQuery.getSelectedFile();
        // Inserisce il documento corrente nel file selezionato
        KDDQuery q = new KDDQuery(file.getAbsolutePath(), doc_query);
        q.saveToRepository();

        jTextArea3.append("Saving < " + file.getAbsolutePath() + " >\n");
      }
      catch (Exception ex) {
        jTextArea3.append("Error saving < " + file.getAbsolutePath() + " >\n");
        System.out.println(ex.toString());
      }
    }
    else {
      jTextArea3.append("Save command aborted by user." + "\n");
    }
  }

  /**
   * Metodo per la chiusura dell'interfaccia;
   * e' invocato quando viene chiusa la finestra generale..
   *
   */
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  /**
   * Metodo invocato quando si inserisce un elemento nel documento corrente
   */
  class InsertListener
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      if (stato == 0 || stato == 5) { // Controlla che sia stato selezionato un elemento
        int sel = jList1.getSelectedIndex();
        if (sel == -1) {
          jTextArea3.append("Please select an item!" + "\n");
        }
        else {
          // Nome dell'elemento da inserire
          String name = jList1.getSelectedValue().toString();
          if (name.equals(S_EOC)) {
            // Si e' scelto l'elemento FINE_DICHIARAZIONE
            if (!nodoCorrente.getTagName().equals("KDD_QUERY"))
                  nodoCorrente=(Element) nodoCorrente.getParentNode();

            if (stato == 0) {
              if (nodoCorrente.getTagName().equals("KDD_QUERY"))
              //if (nodoCorrente == null) // Se il nodo corrente non ha padre la query e' terminata
              {
                // controlla la compatibilita' del tag <ALGORITHM>
                //try {
                  QueryExecutor executor = new QueryExecutor(doc_query);
                  jTextArea3.append("Parsing ...     OK\n");
                  //executor.validateQuery();
                  //jTextArea3.append("Validation ...     OK\n");
                  jTextArea3.append(Messages.line);
                  jTextArea3.append("The query created is valid. Press <Execute> to run it.\n");
                  stato = 2;

                /*}
                catch(KDDMLInterpreterException ecc) {
                  jTextArea3.append(Messages.line);
                  jTextArea3.append("The query created is NOT valid: "+ecc.getErrorMessage()+"\n");
                  stato = 6;
                }*/
              }
              else
                AggiornaLista();
            }
            else {
              if (nodoCorrente.getNodeName().equals(changing.getNodeName())) {
                // Se il nodo corrente e' la radice, ho una query valida
                // controlla la compatibilita' del tag <ALGORITHM>
               // try {
                  QueryExecutor executor = new QueryExecutor(doc_query);
                  jTextArea3.append("Parsing ...     OK\n");
                  //executor.validateQuery();
                  //jTextArea3.append("Validation ...     OK\n");

                //}
               /* catch(KDDMLInterpreterException ecc) {
                  jTextArea3.append("The query created is NOT valid: "+ecc.getErrorMessage()+"\n");
                  stato = 6;
                  return;
                }*/
                jTextArea3.append(Messages.line);
                jTextArea3.append("The query created is valid. Press <Execute> to run it.\n");
                int i = 9;
                // riappendo i figli dopo quello modificato
                for (int j = 0; j < 10; j++) {
                  if (listaFigli[i - j] == null) {}
                  else {
                    nodoCorrente.appendChild( (Element) listaFigli[i -
                                             j].cloneNode(true));
                  }
                }
                stato = 2;
                out();
                nodoCorrente = null;
                jTabbedPane1.setSelectedComponent(contentPane5);
              }
              else

                // Richiama aggiornaLista
                AggiornaLista(changing);
            }
          }
          else { // Non si e' scelto FINE_DICHIARAZIONE
            if (stato == 0)
              stato = 1;
            switch (m_dtd.getContentType(name)) {
              // Si controlla il content model dell'elemento e lo si appende al documento
              case -1:
                //jTextArea3.append(
                //    "------------------------------------------------------\n");
                //jTextArea3.append("L'elemento " + name + " non e' dichiarato." +
                //                  "\n");
                break;
              case ElementDecl.EMPTY:
                //jTextArea3.append(
                //    "------------------------------------------------------\n");
                //jTextArea3.append("L'elemento " + name + " e' vuoto." + "\n");
                AppendiFiglio(name);
                break;
              case ElementDecl.ANY:
                //jTextArea3.append(
                //    "------------------------------------------------------\n");
                //jTextArea3.append("L'elemento " + name + " e' dichiarato ANY." +
                //                  "\n");
                break;

              case ElementDecl.MODEL_GROUP:
                AppendiFiglio(name);
                break;
            }
          }
        }
      }
      else
        jTextArea3.append("No Element to Add!\n");
    }
  }

  // Metodo invocato dopo l'inserimento dei valori per gli attributi
  class OKListener
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {

      if ((nodoCorrente.getTagName().equals("ARFF_LOADER")) && (arff_splitter != null)) {
        fields[0] = new JTextField(arff_splitter.getPath());
        fields[2] = new JTextField(arff_splitter.getName());
        contentPane3.remove(arff_button);
      }


      //System.out.println("pos"+posizione);
      commento = new String();
      if (stato == 1 || stato == 4 || stato == 5) {
      // Controllo dello stato
        boolean ok = true;
        // Caso di elemento senza attributi
        if (labels[0].getText().startsWith("The element")) {
          out();
          jTabbedPane2.setSelectedComponent(contentPane2);
          if (stato == 5) {
            AggiornaLista(changing);
          }
          else {
            stato = 0;
            AggiornaLista();
          }
        }
        else {
          boolean[] insert = new boolean[10];
          boolean implied = false;
          boolean fixed = false;
          for (int i = 0; i < posizione; i++) {
            // Si controllano tutti gli attributi
            if (labels[i].getText().endsWith("(*)"))
              labels[i].setText(labels[i].getText().substring(0, labels[i].getText().length()-4));
            AttDef attDef = m_dtd.getAttributeDeclaration(nodoCorrente.getTagName(), labels[i].getText());

            //System.out.println("Attribute Definition!!!!!!!!!!");
            //System.out.println("Name: "+attDef.getName());
            //System.out.println("Type: "+attDef.getNodeType());

            if (attDef.getDefaultType() == AttDef.IMPLIED)
              // IMPLIED Attribute
              implied = true;

            if (fields[i] instanceof JTextField)
              if ( ( ( (JTextField) fields[i]).getText().equals(new String())) && !implied) {
                commento = commento + "Attribute < "+ labels[i].getText() + " > is required!\n";
                ok = false;
              }
              else
              if (! ( (JTextField) fields[i]).getText().equals(new String())) {
                insert[i] = true;
              }
              else
                insert[i] = false;
            else
              insert[i] = true;
          }
          if (ok) { // Se tutti i valori sono giusti si inseriscono gli attributi nell'elemento
            for (int i = 0; i < posizione; i++) {
              if (insert[i]) {
                if (fields[i] instanceof JTextField) {
                  nodoCorrente.setAttribute(labels[i].getText(), ((JTextField) fields[i]).getText());
                }
                else {
                  nodoCorrente.setAttribute(labels[i].getText(),
                                            (String) ((JComboBox) fields[i]).getSelectedItem());

                }
              }
            }
            out();
            //stato = 0;
            contentPane3.remove(jLabels);
            contentPane3.remove(jFields);
            labels = new JLabel[15];
            fields = new JComponent[15];
            jLabels = new JPanel();
            jFields = new JPanel();
            jLabels.setLayout(new BoxLayout(jLabels, BoxLayout.Y_AXIS));
            jFields.setLayout(new BoxLayout(jFields, BoxLayout.Y_AXIS));
            contentPane3.add(jLabels, BorderLayout.WEST);
            contentPane3.add(jFields, BorderLayout.CENTER);
            labels[0] = new JLabel("No Element Selected");
            jLabels.add(Box.createVerticalGlue());
            jLabels.add(labels[0]);
            jLabels.add(Box.createVerticalGlue());
            jTabbedPane2.setSelectedComponent(contentPane2);
            /************************************************************/
            if (stato == 1 || stato == 5) {
              if (stato == 5) {
                AggiornaLista(changing);
              }
              else {
                stato = 0;
                AggiornaLista();
              }
            }
            else {
              jTabbedPane1.setSelectedComponent(contentPane5);
              stato = 2; // lo stato e' 4
            }
            /************************************************************/
          }
          else {
            // Ci sono stati errori; si visualizzano nell'apposito pannello
            jTextArea3.append(commento);
          }
        }
      }
      else {
        jTextArea3.append(
            "------------------------------------------------------\n");
        jTextArea3.append("No attribute to insert!\n");
      }
    }
  }


  class SubmitListener
      implements ActionListener {

    /**
     * Metodo invocato per eseguire la KDD QUERY corrente.
     */
    public void actionPerformed(ActionEvent e) {

      if ((stato == 3) || (stato == 6))
        return;
      if (doc_query == null)
        return;
      QueryExecutor qe;
      KDDMLObject result;
      try {
        // execution query...
        qe = new QueryExecutor(doc_query);
        qe.validateQuery();
        jTextArea3.append("Validation ...     OK\n");
        long start_time = System.currentTimeMillis();
        jTextArea3.append("Execution Start ...\n");
        qe.resolve();
        jTextArea3.append("Execution End. Time: "+(System.currentTimeMillis() - start_time)+" millisec ...\n");
        result = qe.getResult();
      }
      // cattura delle eccezioni e relativa gestione...
      catch(KDDMLInterpreterException ecc1) {
        System.out.println(ecc1.getDetailErrorMessage());
        jTextArea3.append(ecc1.getErrorMessage() + "\n");
        QueryExecutor.removeTmpResults();
        return;
      }
      // traduzione dei risultati...
      try {
        result.saveHTML();
      }
      catch (KDDMLCoreException ex) {
        System.out.println(ex.getDetailErrorMessage());
        jTextArea3.append(ex.getErrorMessage() + "\n");
        QueryExecutor.removeTmpResults();
        return;
      }
      // ... e apertura del browser per la successiva visualizzazione
      //if (result.getType() != KDDMLObjectType.KDDML_SCALAR) {
      String s = result.getPhysicalObject().getAbsolutePath() + ".html";
      //QueryExecutor.removeTmpResults();
      try {
        BrowserManager.openBrowser(new File(s));
      }
      catch (BrowserException ex2) {
        System.out.println(ex2.getErrorMessage());
        jTextArea3.append(ex2.getErrorMessage() + "\n");
        return;
       // }
      }
    }
  }


  /**
   * Listener sul bottone Modify utilizzato per modificare i valori degli attributi di un elemento
   *
   */
  class ModifyListener
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      System.out.println("NOT YET IMPLEMENTED");
      /*stato = 4;
      inserisciAttributi(currEl);
      nodoCorrente = currEl;*/
    }
  }

  /**
   * Listener sul bottone per l'apertura dei file ARFF
   *
   */
  class ARFFListener implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      int returnVal = openARFF.showOpenDialog(File_Frame);
      if (returnVal == JFileChooser.APPROVE_OPTION) {
        File file = openARFF.getSelectedFile();
        try {
          arff_splitter = new ARFFPathSplitter(file.getAbsolutePath());
          OKListener list = new OKListener();
          list.actionPerformed(e);
        }
        catch (IOException ex) {
        }
      }
      else
        arff_splitter = null;
    }
  }

  /**
   * Listener sul bottone change che permette di cambiare l'elemento selezionato
   *
   */
  class ChListener
      implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      System.out.println("NOT YET IMPLEMENTED");
      /*stato = 5;
      // seleziono il padre del nodo da modificare
      nodoCorrente = (Element) currEl.getParentNode();
      int i = 0;
      boolean esco;
      esco = false;
      Element figlio = null;
      Vector figli = XMLUtility.getChildren(nodoCorrente);
      for (int j = figli.size() - 1; (j >= 0 && !esco); j--) {
        figlio = (Element) figli.get(j);

       // if (figlio.getNodeName().equals(currEl.getNodeName()))
          if (figlio.equals(currEl))
          {
            System.out.println("FIGLIO UGUALE A CURRE1 = "+figlio);
            esco = true;
          }
        else {
          listaFigli[i] = (Element) figlio.cloneNode(true);
          //tmp_listaFigli[i]=(Element)tmp_figlio.cloneNode(true);
          i++;
        }
      }
        //cerco che numero di discendente e' il nodo da rimuovere
        NodeList discendenti = m_root.getElementsByTagName("*");
        int k;
        int indiceFiglio = 0;
        boolean trovato = false;
        for (k = 0; (k < discendenti.getLength() && !trovato); k++) {
          System.out.println("DISCENDENTE numero " + k + " = " +
                             discendenti.item(k));
          if (discendenti.item(k).equals(figlio)) {
            System.out.println("FIGLIO TROVATO CON INDICE : " + k);
            indiceFiglio = k;
            trovato = true;
          }
        }

        Node tmp_figlio_da_rimuovere = tmp_m_root.getElementsByTagName("*").
            item(indiceFiglio);
        System.out.println("FIGLIO DA RIMUOVERE numero " + indiceFiglio + ":  " +
                           (Element) tmp_m_root.getElementsByTagName("*").item(
            indiceFiglio));
        Element padre = (Element)tmp_figlio_da_rimuovere.getParentNode();
        Vector tmp_figli = XMLUtility.getChildren(padre);
        esco = false;
        i = 0;
        for (int c = tmp_figli.size() - 1; (c >= 0 && !esco); c--) {
          Element tmp_figlio = (Element) tmp_figli.get(c);

          if (tmp_figlio.equals(tmp_figlio_da_rimuovere)) esco = true;
            else {
              tmp_listaFigli[i] = (Element) tmp_figlio.cloneNode(true);
              i++;
            }
        }
        padre.removeChild(tmp_figlio_da_rimuovere);
        changing = nodoCorrente;

        nodoCorrente.removeChild(figlio);


      // invoco Aggiorna lista per la selezione di un nuovo elemento
      AggiornaLista(nodoCorrente);*/
    }
  }

  /**
   * Effettua il parsing di tutte le DTD.
   */
  public boolean parsingDTDs() throws IOException {

    Vector v = DTDResolver.getNames();
    DTDResolver res = new DTDResolver(KDDMLObjectType.KDD_QUERY);
    String query_dtd = res.getDTDPath();
    for (int i=0; i<v.size(); i++) {
      String dtd_path = (String) v.get(i);
      if (!dtd_path.equals(query_dtd))
        if (DTDParser.parse(dtd_path, parserListener) == null)
          return false;
    }

    // parsing dell'elemento KDDML_QUERY
    m_dtd = DTDParser.parse(query_dtd, parserListener);

    if (null == m_dtd) {
      return false;
    }
    else {

      m_allel = new Vector();
      // Prende la lista degli elementi dichiarati nella DTD
      Enumeration en = m_dtd.getElementDeclarations();
      while (en.hasMoreElements()) {
        ElementDecl ed = (ElementDecl) en.nextElement();
        m_allel.addElement(ed.getName());
      }
      // Crea una tabella hash che contiene tutti gli elementi dichiarati
      m_hash = m_dtd.prepareTable((String) m_allel.elementAt(0));
      en = m_allel.elements();
      while (en.hasMoreElements()) {
        String n = (String) en.nextElement();
        m_hash.put(n, new InsertableElement(n));
      }
      return true;
    }
  }

  /**
   * Metodo utilizzato per aggiornare la tabella hash contenente gli elementi ammissibili
   * come figli di quello corrente.
   *
   * @param dtd la DTD relative alle queries
   * @param el l'elemento DOM corrente
   * @param hash tabella hash
   *
   * @return il vettore contenente i nomi degli elementi ammissibili
   */
  public Vector makeAvailables(DTD dtd, Element el, Hashtable hash) {
    //jTextArea3.append("Dentro make availables");
    Vector v = new Vector();
    //System.out.println("ELEMENTO " + el);
    //System.out.println("LUNGHEZZA " + el.getElementsByTagName("*").getLength());
    /*Enumeration enum2 = hash.elements();
    while (enum.hasMoreElements()) {
      //System.out.println("elemento tabella hash " + enum.nextElement());
    }*/
    //Il Metodo che ci genera eccezione
    hash = dtd.getAppendableElements(el, hash);
    //System.out.println("dopo append degli elementi");
    Enumeration en = hash.elements();
    while (en.hasMoreElements()) {
      InsertableElement ie = (InsertableElement) en.nextElement();
      //System.out.println("dopo append degli elementi");
      if (!ie.name.equals(DTD.CM_ERROR)
          && ie.status) {
        if (ie.name.equals(DTD.CM_EOC))
          v.addElement(S_EOC);
        else
          v.addElement(ie.name);
      }
    }
    return v;
  }

  /**
   * Metodo utilizzato per appendere un figlio all'elemento corrente.
   *
   * @param name nome dell'elemento da appendere
   *
   */
  public void AppendiFiglio(String name) {
    //stato=1;
    Element child = doc_query.createElement(name);
    nodoCorrente.appendChild(child);
    nodoCorrente = child;
    out();
    inserisciAttributi(nodoCorrente);
  }

  /**
   * Metodo che aggiorna la lista degli elementi ammissibili come figli di quello corrente
   *
   */
  public void AggiornaLista() {

    int size = listModel.getSize();
    for (int i = 0; i < size; i++) {
      listModel.remove(0);
    }
    jList1.setSelectedIndex( -1);
    // Aggiorna la tabella hash
    Vector v = makeAvailables(m_dtd, nodoCorrente, m_hash);
    //jTextArea3.append(v.elementAt(0)+"  \n");
    // Controlla se ci sono elementi inseribili
    if (0 == v.size() || (1 == v.size() && S_EOC.equals( (String) v.elementAt(0)))) {

      if (nodoCorrente.getTagName().equals("KDDML_OBJECT")) {
        // Se il nodo corrente e' la radice, ho una query valida
        // controlla la compatibilita' del tag <ALGORITHM>
        /*try {
          QueryExecutor executor = new QueryExecutor(doc_query);
          executor.validateQuery();
        }
        catch(KDDMLInterpreterException ecc) {
          jTextArea3.append("The query created is not valid: "+ecc.getErrorMessage()+"\n");
          stato = 6;
          return;
        }*/

        jTextArea3.append(Messages.line);
        jTextArea3.append("The query created is valid. Press <Execute> to run it.\n");
        stato = 2;
      }
      else {
        // Il padre dell'elemento inserito diviene il nodo corrente.
        nodoCorrente = (Element) nodoCorrente.getParentNode();

        // Richiama aggiornaLista sul nodo corrente
        AggiornaLista();
      }
    }
    else {
      boolean add;
      // ordinamento lessicografico
      TreeSet set = new TreeSet();
      for (int i=0; i<v.size();i++)
        set.add(v.get(i));

      Iterator en = set.iterator();
      while (en.hasNext()) {
        add = true;
        String el = (String) en.next();
        if (kddml.Interpreter.NotYetImplementedException.isNotImplemented(el))
          add = false;
        //Vector figli = NodiFigli.getChildren(nodoCorrente);
        //Element f1 = (Element)figli.get(0);
        //Element f2 = (Element)figli.get(1);
        Element f1 = (Element) nodoCorrente.getElementsByTagName("*").item(0);
        Element f2 = (Element) nodoCorrente.getElementsByTagName("*").item(1);

        if (add)
          listModel.addElement(el.equals(DTD.CM_PCDATA) ? S_TEXT : el);
      }
    }
  }

  /**
   * Metodo che aggiorna la lista degli elementi ammissibili come figli di quello corrente
   * utilizzato in caso di cambio di un elemento esistente
   *
   * @param cambio il padre dell'elemento da modificare
   */
  public void AggiornaLista(Element cambio) {
    int size = listModel.getSize();
    for (int i = 0; i < size; i++) {
      listModel.remove(0);
    }
    jList1.setSelectedIndex( -1);
    // Aggiorna la tabella hash
    Vector v = makeAvailables(m_dtd, nodoCorrente, m_hash);
    // Controlla se ci sono elementi inseribili
    if (0 == v.size() || (1 == v.size() && S_EOC.equals( (String) v.elementAt(0)))) {

      // Il padre dell'elemento inserito diviene il nodo corrente.
      nodoCorrente = (Element) nodoCorrente.getParentNode();
      // se il nodoCorrente e' uguale a cambio la query e' stata modificata correttamente
      if (nodoCorrente.getNodeName().equals(cambio.getNodeName())) {
        // Se il nodo corrente e' la radice, ho una query valida
        jTextArea3.append(
            "------------------------------------------------------\n");
        jTextArea3.append(
            "La query modificata e' valida, premere esegui per eseguirla." +
            "\n");
        int i = 9;
        // riappendo i figli dopo quello modificato
        for (int j = 0; j < 10; j++) {
          if (listaFigli[i - j] == null) {}
          else {
            nodoCorrente.appendChild((Element) listaFigli[i - j].cloneNode(true));
          }
        }
        stato = 2;
        out();
        nodoCorrente = null;
        jTabbedPane1.setSelectedComponent(contentPane5);
      }
      else
        System.out.println("Nodo corrente diverso da cambio");
        // Richiama aggiornaLista
        AggiornaLista(cambio);
    }
    else {
      // mostra la  lista degli elementi inseribili
      Enumeration en = v.elements();
      while (en.hasMoreElements()) {
        String el = (String) en.nextElement();
        if (!kddml.Interpreter.NotYetImplementedException.isNotImplemented(el))
          listModel.addElement(el.equals(DTD.CM_PCDATA) ? S_TEXT : el);
      }
    }
  }

  /**
   * Metodo utilizzato per visualizzare nella form corrispondente la lista degli
   * attributi di un elemento.
   *
   */
  public void inserisciAttributi(Element nodoCorrente) {
    // Prende la lista di attributi associati a un elemento
    Enumeration attributes = m_dtd.getAttributeDeclarations(nodoCorrente.getTagName());
    // Aggiorna il pannello inserisciAttributi
    contentPane3.remove(jLabels);
    contentPane3.remove(jFields);
    labels = new JLabel[28];
    fields = new JComponent[28];
    jLabels = new JPanel();
    jFields = new JPanel();
    jLabels.setLayout(new BoxLayout(jLabels, BoxLayout.Y_AXIS));
    jFields.setLayout(new BoxLayout(jFields, BoxLayout.Y_AXIS));
    contentPane3.add(jLabels, BorderLayout.WEST);
    contentPane3.add(jFields, BorderLayout.CENTER);
    posizione = 0;
    //  Attr[] mattributes=null;
    //Vector mattributes = new Vector(1,1);
    // se stato == 4 allora mi creo un vettore con i valori per gli attributi di nodoCorrente
    if (stato == 4) {
      // mattributes = nodoCorrente.getAttributeArray();

      int y = 0;
      Enumeration attribute = m_dtd.getAttributeDeclarations(nodoCorrente.
          getTagName());
      while (attribute.hasMoreElements()) {
        AttDef ad = (AttDef) attribute.nextElement();
        String nome_attr = ad.getName();
        String value_attr = nodoCorrente.getAttribute(nome_attr);
        Attr elem;
        if (value_attr.equals("")) {
          elem = doc_query.createAttribute(nome_attr);
          elem.setValue("");

          //mattributes[y] = elem;
          // -----------------------------------------------
          // ---------- MODIFICA DI ELENA ------ SCOMMENTARE
          // -----------------------------------------------
          //mattributes.add(y,elem);
        }
        else {
          elem = doc_query.createAttribute(nome_attr);
          elem.setValue(value_attr);

          // -----------------------------------------------
          // ---------- MODIFICA DI ELENA ------ SCOMMENTARE
          // -----------------------------------------------
          //mattributes.add(y,elem);
        }
        y = y + 1;
      }
    }
    jTabbedPane2.setSelectedComponent(contentPane3);
    jLabels.add(Box.createVerticalGlue());
    jFields.add(Box.createVerticalGlue());
    // Controlla se l'elemento corrente ha attributi
    if (!attributes.hasMoreElements()) {
      labels[posizione] = new JLabel("The element < " + nodoCorrente.getTagName() +
                                     " > do not have attributes.");
      fields[posizione] = new JTextField();
      jLabels.add(labels[posizione]);
      posizione++;
    }
    else {
      jTabbedPane2.setSelectedComponent(contentPane3);
      if (nodoCorrente.getTagName().equals("ARFF_LOADER")) {

        contentPane3.add(arff_button, BorderLayout.NORTH);
        arff_splitter = null;
      }

      // Prepara il form per l'inserimento degli attributi
      while (attributes.hasMoreElements()) {
        AttDef ad = (AttDef) attributes.nextElement();
        String str= "";
        if (ad.getDefaultType() == ad.REQUIRED)
          str = " (*)";
        labels[posizione] = new JLabel(ad.getName() + str);

        RepositoryManager rm = new RepositoryManager(nodoCorrente.getTagName());
        if (rm.isAccessed() && (ad.getName().equals("xml_source"))) {
          // viene acceduto un repository del sistema
          jComboBox = rm.getComboBox();
          fields[posizione] = jComboBox;
        }

        else {
          AttDef def = m_dtd.getAttributeDeclaration(nodoCorrente.getTagName(), ad.getName());
          //System.out.println(ad.getName()+" "+def.getDeclaredType());
          if (def.getDeclaredType() == 10) {
            Enumeration elements = def.elements();
            String[] s = new String[def.size()];
            int i = 0;
            while (elements.hasMoreElements()) {
              s[i] = (String) elements.nextElement();
              i++;
            }
            jComboBox = new JComboBox(s);
            fields[posizione] = jComboBox;
          }
          else {

            // -----------------------------------------------
            // ---------- MODIFICA DI ELENA ------ SCOMMENTARE
            // -----------------------------------------------

            //fields[posizione]=new JTextField();
            // TROVARE IL METODO PER INSERIRE IL VALORE DELL'I-SIMO ATTRIBUTO
            if (stato == 4) {
              //System.out.println("ad.getName() = "+ad.getName());
              //TXAttribute attr = (TXAttribute) mattributes.get(posizione);
              //System.out.println(" mattributes.get(posizione).getName() = "+attr.getName()+" , mattributes[posizione].getValue() = "+attr.getValue());
              //if (attr.getName().equals(""))
              //  fields[posizione]=new JTextField();
              //else
                fields[posizione] = new JTextField(ad.getName());

            }
            else {
              String default_value = ad.getDefaultStringValue();
              if (default_value == null)
                fields[posizione] = new JTextField();
              else
                fields[posizione] = new JTextField(default_value);

              if (ad.getDefaultType() == AttDef.FIXED)
                // fixed attribute --> disable writing of text
                fields[posizione].setEnabled(false);
            }
          }
        }
        labels[posizione].setLabelFor(fields[posizione]);
        labels[posizione].setMaximumSize(new Dimension(200, 20));
        fields[posizione].setMaximumSize(new Dimension(200, 20));
        labels[posizione].setAlignmentX(Component.CENTER_ALIGNMENT);
        fields[posizione].setAlignmentX(Component.CENTER_ALIGNMENT);
        jLabels.add(labels[posizione]);
        jLabels.add(Box.createVerticalGlue());
        jFields.add(fields[posizione]);
        jFields.add(Box.createVerticalGlue());
        posizione++;
      }
      // jTabbedPane2.setSelectedComponent(contentPane2);
      // jTabbedPane2.setSelectedComponent(contentPane3);
    }
  }

  /**
   * Metodo che crea il JTree contenente la rappresentazione grafica del documento XML corrente.
   *
   * @param el la radice del documento corrente
   *
   */
  public void TreeView1(Element el) {
    DefaultMutableTreeNode corrente = new DefaultMutableTreeNode(el.getTagName());

    //corrente.removeFromParent();
    tree = new JTree(corrente);

    tree.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
    tree.addTreeSelectionListener(new TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        DefaultMutableTreeNode node = (DefaultMutableTreeNode)
            tree.getLastSelectedPathComponent();

        if (node == null)
          return;
        int livello = node.getLevel();
        TreeNode nodeInfo = (TreeNode) node.getUserObject();
        currEl = nodeInfo.el;
      }
    }
    );
    Element child = (Element) m_root.getElementsByTagName("*").item(0);
    if (child != null)

      //TreeView(child,corrente);
      // Passando come parametro la radice el del documento a TreeView, viene visualizzata la radice
      // KDDML_OBJECT e tutti i suoi figli che possono essere pi KDD_QUERY
      TreeView(el, corrente);
  }

  /**
   * Metodo che aggiunge il sottoalbero corrispondente all'elemento corrente al JTree.
   *
   * @param el l'elemento DOM corrente
   * @param jnode il nodo corrente del JTree
   *
   */
  public void TreeView(Element el, DefaultMutableTreeNode jnode) {
    // Caso base, l'elemento da aggiungere non ha figli
    Element el1;
    if (el.getElementsByTagName("*").item(0) == null) {
      jnode.add(creaNodo(el));
    }
    else
    // Caso induttivo, l'elemento ha figli
    { //if ((el.getNthElementNamed(0,"*").getTagName()).equals("KDDML_OBJECT")) {    el1 = m_root.getNthElementNamed(0,"*");}
      el1 = el;
      DefaultMutableTreeNode corrente = creaNodo(el1);
      jnode.add(corrente); // aggiunge il nodo corrente
      //int i= 0;
      // Richiama il metodo per tutti i figli
      Vector figli = XMLUtility.getChildren(el1);
      for (int i = 0; i < figli.size(); i++) {
        Element child = (Element) figli.get(i);

        /*for (Element child= (Element)el1.getElementsByTagName("*").item(i);child!=null;
             child=(Element)el1.getElementsByTagName("*").item(i))*/

        //i++;
        TreeView(child, corrente);
      }
    }
  }

  /**
   * Metodo che crea un nodo del JTree, corrispondente all'elemento specificato
   *
   * @param element l'elemento DOM specificato
   *
   * @return il nodo creato
   */

  public DefaultMutableTreeNode creaNodo(Element element) {
    String etichetta = element.getTagName();
    NamedNodeMap attributes = element.getAttributes();
    for (int i = 0; i < attributes.getLength(); i++)
      etichetta = etichetta + " " + ( (Attr) attributes.item(i)).getName() +
          "="
          + ( (Attr) attributes.item(i)).getValue();
    return (new DefaultMutableTreeNode(new TreeNode(etichetta, element)));

  }

  /**
   * Metodo che aggiorna i pannelli contenenti la rappresentazione XML del documento XML corrente
   * e la sua rappresentazione grafica
   *
   */
  public void out() {
    jTextArea1.setText(XMLUtility.toString(m_root));
    //writeXML();
    contentPane6.remove(jScrollPane5);
    TreeView1(m_root);
    jScrollPane5 = new JScrollPane(tree);
    contentPane6.add(jScrollPane5);
    expandTree();
  }

  /**
   * Metodo espande il JTree contenente la KDDQuery corrente.
   *
   */
  public void expandTree() {
    int rows = 0;
    for (int levels = 0; levels < 20; levels++) {
      rows = tree.getRowCount();
      for (int i = 0; i < rows; i++) {
        tree.expandRow(i);
      }
    }
  }

  /**
   * Main Method.
   *
   * @param args String[]
   */
  public static void main(String args[]) {

    GUI gui = new GUI(null);
    jTextArea3.append(Messages.line);
    jTextArea3.append(QueryExecutor.APPLICATION_NAME+"\n");
    jTextArea3.append(QueryExecutor.APPLICATION_VERSION+"\n");
    System.out.println(QueryExecutor.APPLICATION_NAME);
    System.out.println(QueryExecutor.APPLICATION_VERSION);
    jTextArea3.append("Low Level GUI\n");
    jTextArea3.append(Messages.line);
    boolean b = false;
    try {
      b = gui.parsingDTDs();
    }
    catch (IOException ex) {
      jTextArea3.append("Error(s) found during parsing of DTDs:\n");
      jTextArea3.append(ex.toString()+"\n");
    }
    if (b) {
      // I documenti contenenti le DTD sono ben fondati
      jTextArea3.append("No errors or warnings found during parsing of DTDs.\n");
      String[] not_implemented_op = kddml.Interpreter.NotYetImplementedException.getList();
      if (not_implemented_op.length > 0) {
        jTextArea3.append(
            "Warning: some language operators are not yet implemented! \n");
        jTextArea3.append("< " + not_implemented_op.length +
                          " > operators left. \n");
      }
    }

    gui.show();
  }
}
