/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.KDDMLGui;

import com.ibm.xml.parser.ErrorListener;
import javax.swing.JTextArea;

/**
 * Classe che raccoglie gli errori riscontrati dal Parser XML;
 * implementa un'apposita interfaccia definita in XML4J, e scrive direttamente nell'area
 * Commenti dell'interfaccia.
 */

public class GUIErrorListenerDTD implements ErrorListener {

    JTextArea jTextArea;
    String messaggio;
    int num;

    /**
     * Metodo costruttore; crea un'istanza della classe inizializzando i parametri.
     * @param j la jTextArea della GUI
     */

    public GUIErrorListenerDTD(JTextArea j) {
        jTextArea = j;
        messaggio = new String();
        num = 0;
    }

    /**
     * Metodo per la gestione di un errore; e' invocato dal Parser XML ogni volta che e'
     * riscontrato un errore.
     *
     * @param fileName il nome del file contenente il documento XML
     * @param lineNo il numero di linea dell'errore
     * @param charOffset l'offset all'interno della linea dell'errore
     * @param msg il messaggio d'errore
     *
     * @return 1 se l'errore deve incrementare il numero degli errori del Parser, 0 altrimenti
     */

    public int error(String fileName, int lineNo, int charOffset, Object key, String msg) {
        messaggio = new String();
        //lineNo=lineNo-2;
        if (num==0)
          messaggio = messaggio + "The file < "+fileName+" > contains this error(s):\n";
        messaggio = messaggio+lineNo+": "+msg+"\n";
        //jTextArea.append("------------------------------------------------------\n");
        jTextArea.append(messaggio);
        num++;
        return 1;
    }
}
