/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.KDDMLGui;

import java.io.File;
import kddml.Core.RepositoryResolver;

/**
 * This class delete HTML results after transformation.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public class HTMLCleanerUtility {

  public HTMLCleanerUtility() {
  }

  public static void removeHTMLResults() {

    Runtime.getRuntime().gc();
    System.out.println("Remove all temporaly HTML results....");

    String[] elenco = RepositoryResolver.getRepositoryList();
    for(int i=0; i<elenco.length; i++) {
      File dir = new File(elenco[i]);
      File[] list = dir.listFiles();
      if (list != null)
        for (int j=0;j<list.length;j++) {
          if (list[j].getName().endsWith(".html"))
            System.out.println("Removing "+list[j]+": "+list[j].delete());
        }
    }
  }
}
