/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators;

import java.io.Serializable;
import java.util.*;

public abstract class AlgorithmEnum implements Serializable {

  private static int nID;

  /**
   * This hashtable contains all KDDML algorithms.
   * The algorithm name is the key.
   */
  protected static Hashtable enumList = new Hashtable();
  private String value;
  private int ID;

    protected AlgorithmEnum(String value)
    {
       /* if(value != null)
        {
            this.value = new String(value);
        }
        setID(nID++);
        if (!enumList.contains(value))
          enumList.put(value, this);*/
    }

    protected AlgorithmEnum()
    {
    }

    protected int getID()
    {
        return ID;
    }

    protected void setID(int id)
    {
        ID = id;
    }

    public boolean equals(Object obj)
    {
        if(obj == null)
        {
            return false;
        }
        if(0 != getClass().getName().compareTo(obj.getClass().getName()))
        {
            return false;
        }
        AlgorithmEnum obj2 = (AlgorithmEnum) obj;
        if(0 != value.compareTo(obj2.value))
        {
            return false;
        } else
        {
            return ID == obj2.getID();
        }
    }

    protected static void put(String alg_name, Object obj) {
      enumList.put(alg_name.toUpperCase(), obj);
    }

    protected static Object get(String alg_name) {
      return enumList.get(alg_name.toUpperCase());
    }

    /*public static AlgorithmFactor[] list() {
      Collection enums = enumList.values();
      int l = enums.toArray().length;
      Iterator iter = enums.iterator();

      AlgorithmFactor values2[] = new AlgorithmFactor[enums.size()];
      int i=0;
      while(iter.hasNext()) {
        values2[i] = (AlgorithmFactor) iter.next();
        i++;
      }

      return values2;
    }*/
}
