/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators;

import java.util.Hashtable;
import kddml.Operators.*;
import kddml.Core.KDDMLScalarManager;

public abstract class AlgorithmSettings extends KDDMLOperatorSettings {

  public String algorithm_name;

  public AlgorithmSettings() {
    super();
    algorithm_name = null;
  }

  public void applySettings(Hashtable attributes)
      throws KDDMLOperatorException {

    super.applySettings(attributes);
    setAlgorithmName(attributes, "algorithm_name", true);
  }

  protected void setAlgorithmName(Hashtable attributes, String attribute_name, boolean error_if_not_found)
      throws kddml.Operators.KDDMLOperatorException {

    if (existAttribute(attributes, attribute_name, error_if_not_found)) {
      KDDMLScalarManager s = (KDDMLScalarManager) attributes.get(attribute_name);
      algorithm_name = (String) s.getExprValue();
    }
  }

  public void setAlgorithmName(String algorithm_name) {
    this.algorithm_name = algorithm_name;
  }

  public String getAlgorithmName() {
    return algorithm_name;
  }
}
