/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.DataMining.AssociationAlgorithms;

import kddml.Operators.KDDMLOperatorException;
import kddml.Operators.DataMining.*;
import kddml.Operators.*;

public class DCI_SETTINGS extends RDA_MINER_SETTINGS implements AlgorithmSettingsTask {

  private final static String MIN_SUPPORT_ATTRIBUTE = "min_support";
  private final static String MIN_CONFIDENCE_ATTRIBUTE = "min_confidence";
  private final static String MAX_RULES_ATTRIBUTE = "max_number_of_rules";
  private final static String MAX_ITEMSETS_ATTRIBUTE = "max_number_of_itemsets";

  public DCI_SETTINGS() {
    super();
  }

  public String[] getSupportedParameters() {
    String[] s = {
        MIN_SUPPORT_ATTRIBUTE, MIN_CONFIDENCE_ATTRIBUTE,
        MAX_RULES_ATTRIBUTE, MAX_ITEMSETS_ATTRIBUTE};
    return s;
  }

  public void applyAlgorithmSettings(java.util.Hashtable attributes)
      throws KDDMLOperatorException {

    setMinSupport(attributes, MIN_SUPPORT_ATTRIBUTE, true);
    setMinConfidence(attributes, MIN_CONFIDENCE_ATTRIBUTE, true);
    setMaxNumberOfRules(attributes, MAX_RULES_ATTRIBUTE, false);
    setMaxNumberOfItemsets(attributes, MAX_ITEMSETS_ATTRIBUTE, false);

  }
}
