/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.DataMining.ClusteringAlgorithms;

import kddml.Operators.KDDMLOperatorException;
import kddml.Operators.DataMining.*;
import kddml.Operators.*;
import kddml.Core.KDDMLScalarManager;
import java.util.Hashtable;

public class KMEANS_SETTINGS extends CLUSTER_MINER_SETTINGS implements AlgorithmSettingsTask {

  private final static String NUM_CLUSTERS_ATTRIBUTE = "number_of_clusters";

  public KMEANS_SETTINGS() {
    super();
    // default 2 clusters
    super.k = new Integer(2);
  }

  public String[] getSupportedParameters() {
    String[] s = {NUM_CLUSTERS_ATTRIBUTE};
    return s;
  }

  public void applyAlgorithmSettings(java.util.Hashtable attributes)
      throws KDDMLOperatorException {

    super.setNumberOfClusters(attributes, NUM_CLUSTERS_ATTRIBUTE, false);
  }
}
