/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.DataMining;

import java.util.Hashtable;
import kddml.Operators.*;

public abstract class DMAlgorithmSettings extends kddml.Operators.AlgorithmSettings {

  /**
   * Settings per lo specifico algoritmo
   */
  public AlgorithmSettings alg_settings;

  public DMAlgorithmSettings() {
    super();
  }

  public void applySettings(Hashtable attributes)
      throws KDDMLOperatorException {

    super.applySettings(attributes);
    AlgorithmFactory factory = new AlgorithmFactory(algorithm_name.toUpperCase());
    if (!factory.isSupported()) {
      throw new KDDMLOperatorException
          ("Algorithm < " + algorithm_name + " > not supported!", null,
           KDDMLOperatorErrorCodes.UNSUPPORTED_ALGORITHM);
    }

    alg_settings = (AlgorithmSettings) factory.newSettingsInstance();
    // setta l'xml_dest...
    alg_settings.setXMLDestination(this.xml_dest);
    ((AlgorithmSettingsTask) alg_settings).applyAlgorithmSettings(attributes);
  }
}
