/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Operators.DataMining.SequenceAlgorithms;

import kddml.Core.DataMining.SequentialPatterns.SequenceModel;
import kddml.Operators.*;
import kddml.Core.KDDMLCoreException;
import kddml.Operators.DataMining.DMAlgorithmResolverTask;

/**
 * Interface for sequence algorithms.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public interface SequenceAlgorithmResolverTask extends DMAlgorithmResolverTask {

  /**
   * Formatting of the result.
   *
   * @param execute_result Object the result of the execute method. Can be null.
   * @throws KDDMLOperatorException exception raised at operator level if an error occours.
   * @throws KDDMLCoreException exception raised at core level if an error occours.
   * @return AssociationModel the output model.
   */
  public abstract SequenceModel outputFormatting(Object execute_result)
      throws KDDMLOperatorException, KDDMLCoreException;

}
