/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Operators.IO.ExternalResourceReader;

import kddml.Core.KDDMLCoreException;
import kddml.Core.KDDMLObject;
import kddml.Operators.KDDMLOperatorException;
import kddml.Core.DataMining.SequentialPatterns.PMMLSequenceFactory;
import kddml.Core.DataMining.SequentialPatterns.SequenceModel;
import java.io.File;

/**
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Daniele Cerra (daniele@cerra.info)
 * @version 2.0.0 alfa
 */
public class PMML_SEQUENCE_LOADER_RESOLVER extends ExternalResourceReaderResolver {

  public KDDMLObject importObject(ExternalResourceReaderSettings settings)
      throws KDDMLOperatorException, KDDMLCoreException {

    String xml_dest = ((PMML_SEQUENCE_LOADER_SETTINGS) settings).getXMLDestination();
    String pmml_path = ((PMML_SEQUENCE_LOADER_SETTINGS) settings).getPMMLPath();

    File dest = new File(kddml.Core.KDDMLObjectType.PMML_SEQUENCE_MODEL.getRepositoryPath()+ xml_dest);
    PMMLSequenceFactory fact = new PMMLSequenceFactory(dest, pmml_path);

    return (SequenceModel) fact.newInstance();

  }
}
