/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.IO.RepositoryResourceReader;

import kddml.Operators.KDDMLOperatorException;
import java.io.File;
import kddml.Core.DataMining.Taxonomy.HierarchyRepositoryFactory;
import kddml.Core.DataMining.Taxonomy.HierarchyModel;
import kddml.Core.KDDMLCoreException;

public class HIERARCHY_LOADER_RESOLVER extends RepositoryResourceReaderResolver {

  public kddml.Core.KDDMLObject importObject(String xml_source)
      throws KDDMLOperatorException, KDDMLCoreException {

    File f = new File(kddml.Core.KDDMLObjectType.PMML_HIERARCHY.getRepositoryPath() + xml_source);
    HierarchyRepositoryFactory fact = new HierarchyRepositoryFactory(f);

    return (HierarchyModel) fact.newInstance();
  }
}
