/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.IO.RepositoryResourceReader;

import kddml.Core.KDDMLCoreException;
import kddml.Core.DataMining.AssociationRules.*;
import kddml.Core.KDDMLObject;
import java.io.*;
import kddml.Operators.KDDMLOperatorException;

/**
 * Estrazione di una sorgente dati di tipo ARFF.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */

public class RDA_LOADER_RESOLVER extends RepositoryResourceReaderResolver {

  public KDDMLObject importObject(String xml_source)
      throws KDDMLOperatorException, KDDMLCoreException {

    File f = new File(kddml.Core.KDDMLObjectType.PMML_ASSOCIATION_MODEL.getRepositoryPath()+ xml_source);
    AssociationRepositoryFactory fact = new AssociationRepositoryFactory(f);

    return (AssociationModel) fact.newInstance();
  }
}
