/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators;

/**
 * The interface KDDMLOperatorsErrorCodes defines the error codes to be used in the kddml
 * Operators package.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public interface KDDMLOperatorErrorCodes {

  public final static int INVALID_SETTINGS = 0;

  public final static int ILLEGAL_CASTING = 1;

  public final static int UNSUPPORTED_ALGORITHM = 2;

  public final static int NOT_YET_IMPLEMENTED = 3;

  public final static int UNSUPPORTED_OPERATOR = 4;

  public final static int IO_ERROR = 5;

  public final static int ERROR_INVOKING_EXTERNAL_LIBRARIES = 6;

  public final static int ATTRIBUTE_DO_NOT_EXIST = 7;

  public final static int ATTRIBUTE_TYPE_ERROR = 8;

  public final static int ATTRIBUTE_ALREADY_EXIST = 9;

  public final static int OUT_OF_MEMORY = 10;

  public final static int INCOMPATIBLE_OBJECTS = 11;

  public final static int ALGORITHM_ALREADY_EXIST = 9;
}
