/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.Postprocessing;

import kddml.Core.DataMining.AssociationRules.TransactionManager;

public class RDA_EXCEPTION_RESOLVER extends RDA_SATISFY_RESOLVER {

  /**
   * Test if a transaction is supported by the set of association rules.
   *
   * @param transaction Transaction
   * @return boolean
   */
  protected boolean isSupportedByRda(TransactionManager transaction) {
    return !super.isSupportedByRda(transaction);
  }

  /**
   * Test if a transaction is supported by the set of itemset.
   *
   * @param transaction Transaction
   * @return boolean
   */
  protected boolean isSupportedByItemset(TransactionManager transaction) {
    return !super.isSupportedByItemset(transaction);
  }

  /**
   * The estimated RAM usage for the operator.
   * Must be a value between 0 and 1024 MB.
   *
   * @return boolean
   */
  public int estimatedRAMUsage() {
    return 512;
  }

  /**
   * Return true if the operator performe an high number of access to the hard disk.
   *
   * @return boolean
   */
  public boolean highDiskAccessIsNeeded() {
    return true;
  }
}

