package kddml.Operators.Preprocessing.NormalizationAlgorithms;

import kddml.Operators.*;
import kddml.Operators.Preprocessing.PPAlgorithmResolverTask;

/**
 * Interface for normalization algorithms.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public interface NormalizationAlgorithmResolverTask extends PPAlgorithmResolverTask {

  /**
   * Return the normalized value.
   *
   * @param value double
   * @return Double
   */
  public double normalize(String attribute_name, double value)
      throws kddml.Operators.KDDMLOperatorException;

  /**
   * Read the data statistics
   *
   * @param settings KDDMLOperatorSettings
   */
  public void readStatistics(kddml.Core.DataSources.DataStatisticsManager statistic)
      throws KDDMLOperatorException, kddml.Core.KDDMLCoreException;

  /**
   * Get the description for this algorithm.
   *
   * @return String
   */
  public String getDescription();
}
