package kddml.Operators.Preprocessing.NormalizationAlgorithms;

import kddml.Operators.KDDMLOperatorException;
import weka.core.*;
import kddml.Core.DataSources.*;
import kddml.Core.*;
import kddml.Operators.*;

public class Z_SCORE_NORMALIZATION_RESOLVER implements NormalizationAlgorithmResolverTask {

  private DataStatisticsManager statistic;

  public void readSettings(KDDMLOperatorSettings settings) {

  }

  public void readStatistics(DataStatisticsManager statistic)
      throws KDDMLOperatorException, KDDMLCoreException {

    this.statistic = statistic;
  }

  /**
   * v' = ( v  media(A) ) / dev_standard(A)
   *
   * @param attribute_name String
   * @param value double
   * @return Double
   */
  public double normalize(String attribute_name, double value) {

    // get the mean and variance for the input attribute...
    AttributeStatisticManager attr = statistic.getStatistic(attribute_name);
    double mean = ((NumericalStatistic) attr).getMean();
    double variance = ((NumericalStatistic) attr).getVariance();

    return ((value - mean) / variance);
  }


  public String getDescription() {
    String ris = "Normalization - ";
    ris = ris + "Algorithm: z_score_normalization; ";
    return ris;
  }
}
