package kddml.Operators.Preprocessing.SamplingAlgorithms;

import kddml.Operators.KDDMLOperatorException;
import kddml.Operators.Preprocessing.PP_SAMPLING_SETTINGS;
import kddml.Operators.*;

public class SIMPLE_SAMPLING_SETTINGS extends PP_SAMPLING_SETTINGS implements AlgorithmSettingsTask {

  private final static String REPLACEMENT_ATTRIBUTE = "with_replacement";

  private final static String CARDINALITY_PERC_ATTRIBUTE = "percentage";

  private final static String CARDINALITY_ITEM_ATTRIBUTE = "number_of_instances";

  public SIMPLE_SAMPLING_SETTINGS() {
    super();
    with_replacement = false;
  }

  public String[] getSupportedParameters() {
    String[] s = {REPLACEMENT_ATTRIBUTE, CARDINALITY_PERC_ATTRIBUTE, CARDINALITY_ITEM_ATTRIBUTE};
    return s;
  }

  public void applyAlgorithmSettings(java.util.Hashtable attributes)
      throws KDDMLOperatorException {

    super.setPercentage(attributes, CARDINALITY_PERC_ATTRIBUTE, false);
    super.setNumberOfItems(attributes, CARDINALITY_ITEM_ATTRIBUTE, false);
    super.setReplacementStrategy(attributes, REPLACEMENT_ATTRIBUTE, false);

    // cardinality_perc e cardinality_item sono mutuamente esclusivi...
    if ((super.number_of_items == null) && (super.percentage == null)) {
      String s = "< "+CARDINALITY_PERC_ATTRIBUTE+" > and < "+CARDINALITY_ITEM_ATTRIBUTE+" > are"+
          " mutually esclusive attributes.";
      throw new KDDMLOperatorException(s, null, KDDMLOperatorErrorCodes.INVALID_SETTINGS);
    }
  }
}
