/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Operators.Preprocessing.SamplingAlgorithms;

import kddml.Operators.*;
import java.util.Vector;
import java.util.Enumeration;

/**
 * A factory class for sampling algorithms.
 *
 * <p>Title: KDDML</p>
 * <p>Description: Knowledge Discovery in Database Environment</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: Universita' di Pisa - Dipartimento di Informatica</p>
 * @author Andrea Romei (romei@di.unipi.it)
 * @version 1.0
 */
public final class SamplingAlgorithmFactory extends AlgorithmFactory {

  public SamplingAlgorithmFactory(String val) {
      super(val);
  }

  public static AlgorithmFactory[] list() {

    Enumeration enums = enumList.elements();
    Vector tmp = new Vector();
    int cnt = 0;
    while(enums.hasMoreElements()) {

      AlgorithmFactory fact = (AlgorithmFactory) enums.nextElement();
      String class_name = "kddml.Operators.Preprocessing.SamplingAlgorithms.SamplingAlgorithmFactory";
      if (fact.getClass().getName().equals(class_name)) {
        tmp.add(fact);
        cnt++;
      }
    }

    AlgorithmFactory values2[] = new AlgorithmFactory[tmp.size()];
    for (int i=0; i<tmp.size(); i++) {
      values2[i] = (AlgorithmFactory) tmp.get(i);
    }
    return values2;
  }

  public static void main(String[] args) {
    try {
      AlgorithmFactory.initialize();
      System.out.println(SamplingAlgorithmFactory.list().length);
    }
    catch(Exception e) {

    }
  }
}
