/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Operators.Unclassified;

import kddml.Core.*;
import kddml.Operators.*;

public class EXT_CALL_RESOLVER extends kddml.Operators.KDDMLOperatorResolver {

  public kddml.Core.KDDMLObject execute(kddml.Operators.KDDMLOperatorSettings settings,
                                        java.util.Vector arguments)
      throws kddml.Operators.KDDMLOperatorException {

    String exe_path = ((EXT_CALL_SETTINGS) settings).getPath();

    String[] params = new String[arguments.size()];
    for (int i=0; i<arguments.size(); i++) {
      KDDMLScalarManager s = (KDDMLScalarManager) arguments.get(i);
      if (s.getExprType() == KDDMLScalar.STRING)
        params[i] = (String) s.getExprValue();
      else
        params[i] = ((Double) s.getExprValue()).toString();
    }
    boolean b = false;
    try {
      //if (System.getProperty("os.name").indexOf("Windows") != -1) {

        // Windows operative System
        b = callResource(exe_path, params);
     // }

     // if (System.getProperty("os.name").indexOf("Linux") != -1) {

        // Linux operative System
     //   b = callResourceForLinux(exe_path, params);

     // }
    }
    catch (Exception ec) {
      String msg1 = "Error invoking external resource: invalid command!!!";
      String msg2 = ec.toString();
      throw new KDDMLOperatorException(msg1, msg2, KDDMLOperatorErrorCodes.ERROR_INVOKING_EXTERNAL_LIBRARIES);
    }

    // restituisce l'esito della chiamata...
    String xml_dest = kddml.Core.KDDMLObjectType.KDDML_SCALAR.getRepositoryPath() +
        ((EXT_CALL_SETTINGS) settings).getXMLDestination();
    KDDMLScalar ris = new KDDMLScalar(new java.io.File(xml_dest), new Boolean(b).toString());
    return ris;
  }

  public kddml.Core.KDDMLObjectType getParamType(int i) {
    return KDDMLObjectType.KDDML_SCALAR;
  }

  private static boolean callResource(String exe, String[] params)
      throws java.io.IOException, InterruptedException {

    Runtime esegui = Runtime.getRuntime();
    String[] exec = new String[params.length + 1];
    exec[0] = exe;
    for (int i=0; i<params.length; i++)
      exec[i+1] = params[i];

    Process p = esegui.exec(exec);
    p.waitFor();

    if (p.exitValue() == 0)
      return true;
    return false;
  }
}
