/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */


package kddml.Operators.Unclassified;

import kddml.Core.KDDMLScalar;

public class SCALAR_RESOLVER extends kddml.Operators.KDDMLOperatorResolver {

  public kddml.Core.KDDMLObject execute(kddml.Operators.KDDMLOperatorSettings settings,
                                        java.util.Vector arguments)
      throws kddml.Operators.KDDMLOperatorException {

    String obj = ((SCALAR_SETTINGS) settings).getValue().getExprValue().toString();
    String xml_dest = kddml.Core.KDDMLObjectType.KDDML_SCALAR.getRepositoryPath() +
        ((SCALAR_SETTINGS) settings).getXMLDestination();
    KDDMLScalar ris = new KDDMLScalar(new java.io.File(xml_dest), obj);
    return ris;
  }

  public kddml.Core.KDDMLObjectType getParamType(int i) {
    return null;
  }

  /**
   * The estimated RAM usage for the operator.
   * Must be a value between 0 and 1024 MB.
   *
   * @return boolean
   */
  public int estimatedRAMUsage() {
    return 0;
  }
}
