/*
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *    ------------------------------------------------------------------------
 *    Copyright (C) 2004-2005
 *    Dipartimento di Informatica, Universita' di Pisa
 *    Pisa, Italy
 *    ------------------------------------------------------------------------
 *
 */

package kddml.Operators.Unclassified;

import kddml.Core.KDDMLScalar;
import kddml.Core.KDDMLScalarManager;
import java.util.Hashtable;
import kddml.Operators.KDDMLOperatorException;
import kddml.Operators.KDDMLOperatorErrorCodes;

public class SCALAR_SETTINGS extends kddml.Operators.KDDMLOperatorSettings {

  private final static String VALUE_ATTRIBUTE = "value";

  private KDDMLScalarManager value;

  public SCALAR_SETTINGS() {
    super();
  }

  public void applySettings(java.util.Hashtable attributes)
      throws kddml.Operators.KDDMLOperatorException {

    super.applySettings(attributes);
    setValue(attributes, VALUE_ATTRIBUTE, true);
  }

  protected void setValue(Hashtable attributes,
                          String attribute_name,
                          boolean error_if_not_found)
      throws KDDMLOperatorException {

    if (existAttribute(attributes, attribute_name, error_if_not_found)) {
      try {
        value = (KDDMLScalarManager) attributes.get(attribute_name);
      }
      catch(Exception e) {
        throw new KDDMLOperatorException
            ("< "+attribute_name+" >"+" must be a string.",
             null,
             KDDMLOperatorErrorCodes.ILLEGAL_CASTING);
      }
    }
  }

  public void setValue(String value) {
    this.value = new KDDMLScalar(null, value);
  }

  public KDDMLScalarManager getValue() {
    return value;
  }
}
