#include <stdio.h>
#include "database.h"

void DissociaDato (Attributo attr, int tag, char *stringa);
int AssociaDato (Attributo attr, char *stringa);
void AllocDatabase (Database *dat);
void LeggiAttributi (FILE *fp, Attributo *att, int numatt);
void LeggiTuple (FILE *fp, Database *dat);
void StampaDatabase (Database dat);
void StampaAttributi (Attributo *list, int numatt);
void LeggiDatabase (Database *dat, char* comand);
void LeggiDatabaseTest (Database *dat, char* comand);



void DissociaDato (Attributo attr, int tag, char *string)
{ 
 
 sprintf (string,"err");
  
 if (attr.continuo)
      { 	
	if (tag<=attr.numdominio)
   	   { 
       	     if (tag==0) 
		sprintf (string,"-%s",attr.dominio[0]);
	     else 
		if (tag==attr.numdominio) 
		     sprintf (string,"%s-",attr.dominio[attr.numdominio-1]);
		else
		      sprintf (string,"%s-%s",attr.dominio[tag-1],attr.dominio[tag]); 		
	      
      		   }
	 }
	
  else
  	sprintf (string,"%s",attr.dominio[tag]);
  	 
 
 }


int AssociaDato (Attributo attr, char *stringa)
{ 
  int i, numb, assoc=-1;

  if (attr.continuo)
	{   numb = atoi (stringa);
            if (numb <= atoi (attr.dominio[0]))
		assoc = 0;
             if (numb > atoi (attr.dominio[attr.numdominio-1]))
		assoc = attr.numdominio;

	    for (i=1; i<attr.numdominio; i++)
		if ( ( numb <= atoi (attr.dominio[i])) && (numb > atoi (attr.dominio[i-1]) ) )
			assoc = i;
		 }
  else
	{ 	    for (i=0; i<attr.numdominio; i++)
		 if (!strcmp (stringa, attr.dominio[i]))
			assoc = i;
			}
  if (assoc==-1) 
		printf ("Errore nella lettura tuple: attributo %s non appartenente  al dominio %s\n",stringa,attr.nome);
  return assoc;
}

void AllocDatabase (Database *dat)
{ 
  int i;

  /* alloco la memoria per gli attributi discretizzati e per il numero di valori per att.*/
  dat->listatt = (Attributo *) malloc (sizeof(Attributo) * dat->numtuple);
            
   /* alloco la memoria per le tuple */
   dat->data =  (int **) malloc (sizeof(int*) * dat->numtuple);
   for (i=0; i<dat->numtuple; i++)
   dat->data[i] =  (int *) malloc (sizeof (int*) * dat->numatt);
	   
}

void LeggiAttributi (FILE *fp, Attributo *att, int numatt)
{ 
  int i,j,k;
  char ch;
  for (i=0; i<numatt; i++)
       { 
           fscanf (fp, "%s %d %d ", & (att[i].nome), &(att[i].continuo), &(att[i].numdominio));
 	   att[i].dominio = (char **) malloc (sizeof (char*) * att[i].numdominio);
           for (j=0; j<att[i].numdominio; j++)
		{
		att[i].dominio[j] = (char *) malloc (sizeof (char) * MAXCHARATT);
		k=0;
	        while ( (ch = getc (fp)) == ' ');
		while ( (k<(MAXCHARATT-1)) && (ch != ',') && ( ch!='\n') )	 
			{  
                            if (ch=='\\')
                                   ch=getc(fp);
			    att[i].dominio[j][k] = ch;
			    k++; ch = getc(fp);
			  	  }
                att[i].dominio[j][k] = '\0';
    		while ( (ch!=',') && (ch!=' ') && (ch!='\n') )
			ch = getc(fp);
 			}
	  fscanf (fp, "\n");
         }
   }

void StampaAttributi (Attributo *list, int numatt)
{  
int i,j;
printf ("Stampa Attributi\n\n");
for (i=0; i<numatt;i++)
      {   printf(" att %d = %s n=%d : ",i,list[i].nome,list[i].numdominio);
          for (j=0;j<list[i].numdominio;j++)
              printf (" %s # ", list[i].dominio[j]); 
          
        printf("\n");
       }
}

void LeggiTuple (FILE *fp, Database *dat)
{ 
  int i,j,k;
  char ch, stringa[MAXCHARATT];
    	
   for (i=0; i<dat->numtuple; i++)
       for (j=0; j<dat->numatt;j++)
	    {  
		k=0;
		while ( (ch=getc(fp))==' ');	
		while ( (k<(MAXCHARATT-1)) && (ch != ',') && ( ch!='\n') && (ch!='.') )	 
			{  
                            if(ch=='\\')
                                  ch=getc(fp);
			    stringa[k] = ch;
			    k++; ch = getc(fp);
			  	  }
                 stringa[k] = '\0';
		 while ( (ch!=',') && (ch!=' ') && (ch!='\n') )
			ch = getc(fp);
                /* associa un intero alla stringa nel dominio */ 
		/*printf ("%d %s $ ",j,stringa);*/
		dat->data[i][j] = AssociaDato (dat->listatt[j],stringa);
	        	  
	  } /* fine for j */
  
} /* fine LeggiTuple */

void StampaDatabase (Database dat)
{ 
 int i,j;
 char stringa[2*MAXCHARATT+1];

   printf ("Database tuple = %d attributi = %d\n",dat.numtuple,dat.numatt);
   for (i=0; i<dat.numtuple;i++)
	{   for (j=0; j<dat.numatt;j++)
		{
		  DissociaDato (dat.listatt[j], dat.data[i][j],stringa);
		  printf ("%s ",stringa );
		}
		printf ("\n"); 
	    }
	   
}

void LeggiDatabase (Database *dat, char* comand)
{ 
FILE *fp, *fptemp;
char nomefile[80];

    sprintf (nomefile,"data/%s.data",comand);
    fp = fopen (nomefile,"r");
    if (fp!=NULL)	
      { 
      sprintf(nomefile,"data/%s.discr",comand);
      fptemp = fopen (nomefile,"r");
      if (fptemp!=NULL)
        {    	
	fscanf (fptemp, "%d %d\n",&(dat->numtuple), &(dat->numatt));

    	AllocDatabase (dat); 
        /* leggo gli attributi discretizzati */
        LeggiAttributi (fptemp, dat->listatt, dat->numatt);		
	fclose (fptemp);
        StampaAttributi(dat->listatt, dat->numatt);

               	/* leggo le tuple */
	LeggiTuple (fp,dat);
      	} /* fine  if fptemp .. */
      else
         printf ("Can't open file %s\n",nomefile);
	fclose (fp);
	   }
    else
         printf ("Can't open file %s\n",nomefile);

}  /* fine LeggiDatabase */


void LeggiDatabaseTest (Database *dat, char* comand)
{ 
FILE *fp, *fptemp;
char nomefile[80];

    sprintf (nomefile,"data/%s.test",comand);
    fp = fopen (nomefile,"r");
    if (fp!=NULL)	
      { 
      sprintf(nomefile,"data/%s.discrt",comand);
      fptemp = fopen (nomefile,"r");
      if (fptemp!=NULL)
        {    	
	fscanf (fptemp, "%d %d\n",&(dat->numtuple), &(dat->numatt));

    	AllocDatabase (dat); 
        /* leggo gli attributi discretizzati */
        LeggiAttributi (fptemp, dat->listatt, dat->numatt);		
	fclose (fptemp);

        	/* leggo le tuple */
	LeggiTuple (fp,dat);
      	} /* fine  if fptemp .. */
      else
         printf ("Can't open file %s\n",nomefile);
	fclose (fp);
	   }
    else
         printf ("Can't open file %s\n",nomefile);

}  /* fine LeggiDatabase */

void main(argc,argv)
int argc;
char *argv[ ];
   
{

int  i,j;
FILE  *fp,*fptemp;
char nomefile[80];
Attributo *att;
int numatt,numtuple;
char comand[80];

 if (argc>1) 
   {
     sprintf (nomefile,"data/%s.data",argv[1]);
    fp = fopen (nomefile,"r");
    if (fp!=NULL)	
      { 
      sprintf(nomefile,"data/%s.discr",argv[1]);
      fptemp = fopen (nomefile,"r");
      if (fptemp!=NULL)
        {    	
	fscanf (fptemp, "%d %d\n",&(numtuple), &(numatt));
         printf ("att= %d \n",numatt);
        att = (Attributo *) malloc (sizeof(Attributo)*numatt); 
        /*leggo gli attributi discretizzati */
        LeggiAttributi (fptemp, att, numatt);		
	fclose (fptemp);
        StampaAttributi(att, numatt);
       fclose(fp);
       fp = fopen("setup.c","w");
       fprintf (fp,"#include <stdio.h>\n#include \"gpc.h\"\n#include \"prob.h\"\n#include \"database.h\"\n\nextern int current;\nextern Database dat;\n\n");

       fprintf (fp, "#ifdef ANSI_FUNC\n\nVOID make_function_table(int 	numpops,pop_struct *pop)\n#else\n
VOID make_function_table(numpops,pop)\n  int		numpops;\n  pop_struct	*pop;\n#endif\n\n{\n");

      fprintf (fp,"int	p;\n\n for (p=0; p<numpops; p++) {\n   pop[p].function_table_size = %d;\npop[p].function_table = (function_table_entry *) malloc(pop[p].function_table_size*sizeof(function_table_entry));\n\n",numatt-1);

     for (i=0;i<numatt-1;i++)
          fprintf (fp," pop[p].function_table[%d].arity =%d;\n  pop[p].function_table[%d].macro = TRUE;\n pop[p].function_table[%d].enabled = TRUE;\n pop[p].function_table[%d].printname = \"%s\";\n pop[p].function_table[%d].code = attX%d;\n\n",i,att[i].numdominio,i,i,i,att[i].nome,i,i+1);
          fprintf (fp," \n\n }\n}\n\n");
  fprintf (fp,"#ifdef ANSI_FUNC\nVOID make_terminal_table(int		numpops, pop_struct 	*pop)\n#else \n\nVOID make_terminal_table(numpops,pop)\nint		numpops;\npop_struct 	*pop;\n#endif\n{\n\n");
  fprintf (fp," int p;\n\n for (p=0; p<numpops; p++) {pop[p].terminal_table_size = %d;\npop[p].terminal_table =(terminal_table_entry *) malloc((pop[p].terminal_table_size) * sizeof(terminal_table_entry));\n",att[numatt-1].numdominio);

  for (i=0;i<att[numatt-1].numdominio;i++)
  fprintf (fp," pop[p].terminal_table[%d].val = %d;\npop[p].terminal_table[%d].printname = \"%s\";\npop[p].terminal_table[%d].constant_generator = constant%d;\n",i,i,i,att[numatt-1].dominio[i],i,i);
  fprintf (fp,"pop[p].format = FORMAT;\npop[p].ckpt_format = CKPT_FORMAT;\n\n}\n }\n\n");
  for (i=0;i<numatt-1;i++)
   fprintf (fp,"#ifdef ANSI_FUNC\nGENERIC attX%d(tree **args)\n#else\nGENERIC attX%d(args)\ntree **args\n#endif\n{\nint i;\nfor (i=0; i<dat.listatt[%d].numdominio; i++)\nif (dat.data[current][%d]==i)\n{\n\nreturn eval(args[i]);\n } \n}\n\n",i+1,i+1,i,i);
  for (i=0;i<att[numatt-1].numdominio;i++)
 
  fprintf (fp, "#ifdef ANSI_FUNC\n GENERIC \nconstant%d(void)\n#else
\nGENERIC constant%d()\n#endif\n\n{\nreturn %d;\n}\n\n",i,i,i);
       fclose (fp);
   
   fp =fopen ("func.h","w");
   for (i=0;i<numatt-1;i++)
   fprintf(fp,"GENERIC attX%d P_((tree **args ));\n\n",i+1);
   for (i=0;i<att[numatt-1].numdominio;i++)
     fprintf (fp,"GENERIC constant%d P_((void));\n\n",i);
 
   fclose (fp);

   fp =fopen ("nomefile.h","w");
   fprintf (fp,"char *nomefile = \"%s\";\n",argv[1]);  
 
   fclose (fp);

      }
    }
 else 
   printf ("file not found\n");
   }

 else
    printf (" too few arguments\n");

}

