#include <stdio.h>
#include <malloc.h>
#include <errno.h>
#include "gpc.h"
#include "database.h"
#include "nomefile.h"
#include <math.h>


Database dat,datt,tmpdata;
int current= 0;
double  *coeffA, *coeffB, *coeffAlb, *coeffAlbC;


extern FILE* fptmp;


#ifdef ANSI_FUNC

VOID define_fitness_cases(
  int 		numpops,
  int 		numgens,
  pop_struct	*pop
     )
#else

VOID define_fitness_cases(numpops,numgens,pop)
  int 		numpops;
  int 		numgens;
  pop_struct	*pop;
#endif
{
  FILE *fp;
  char nome[80];
  int i;

  /* this template makes all of the fitness cases the same for all
     populations, but that isn't necessary */
  sprintf (nome,"data/%s.test",nomefile);
  LeggiDatabase (&dat, nomefile);
  
printf("data %d %d\n",myrank, dat.numtuple);

   fp = fopen(nome,"r");
  if (fp==NULL)
     { 
      fprintf(fptmp,"Warning: not exists test set\n");
       LeggiDatabaseTest (&datt,nomefile);
printf("no test %d %d\n",myrank, datt.numtuple);
          }
  else
     {
      fclose(fp);
      LeggiDatabaseTest (&datt,nomefile);
      printf("test %d %d\n",myrank, datt.numtuple);
        }
  fflush(fptmp);
}

#ifdef ANSI_FUNC

VOID evaluate_fitness_of_populations(
     int 	numpops,
     int 	numgens,
     pop_struct	*pop,
     int	p
     )
#else

VOID evaluate_fitness_of_populations(numpops,numgens,pop,p)
     int 	numpops;
     int 	numgens;
     pop_struct	*pop;
     int	p;
#endif
{
  int		i,j,kl;
  tree *tmptree;
  for (i=0; i<pop[p].width; i++)
    for (j=0;j<pop[p].height;j++)
  {kl=0;
    tmptree=convert_buffer(pop,p,pop[p].population[i][j],&kl);
    pop[p].standardized_fitness[i][j] =
      evaluate_fitness_of_individual(pop,p,tmptree,i,j);
   free_tree(tmptree);
  }
}

#ifdef ANSI_FUNC

float evaluate_fitness_of_individual(
     pop_struct	*pop,
     int	p,
     tree	*t,
     int	i,
     int        j
     )
#else

float evaluate_fitness_of_individual(pop, p, t, i,j)
     pop_struct	*pop;
     int	p;
     tree	*t;
     int	i;
     int	j;
#endif
{
 int k,tmp;
  int fit = 0;
  
  
    for (k=0; k<dat.numtuple; k++) {
      current = k;
      tmp=eval(t);
      if (tmp == dat.data[k][dat.numatt-1])
        {
           fit++; }
           }
    return (dat.numtuple-fit);
}

#ifdef ANSI_FUNC
float validate_fitness_of_tree(
     int	numpops,
     int	numgens,
     pop_struct *pop,
     int	p,
     tree 	*t
     )
#else

float validate_fitness_of_tree(numpops, numgens, pop, p, t)
  int		numpops;
  int		numgens;
  pop_struct	*pop;
  int		p;
  tree		*t;
#endif
{
 int		j,tmp;
  float fit;

  /*tmpdata = dat;
  dat = datt;  */

     fit = (float)dat.numtuple;
    for (j=0; j<dat.numtuple; j++) {
       current=j; 
       tmp=eval(t);
       if (tmp == dat.data[j][dat.numatt-1])
         {
            fit=fit-1.0; }
  }
    fit += (float) count_crossover_pts(t)*pop[p].parsimony_factor;
    /*datt =dat; 
    dat = tmpdata;
  */
    return (fit);
}
  
#ifdef ANSI_FUNC
float train_fitness_of_tree(
     int	numpops,
     int	numgens,
     pop_struct *pop,
     int	p,
     tree 	*t
     )
#else

float train_fitness_of_tree(numpops, numgens, pop, p, t)
  int		numpops;
  int		numgens;
  pop_struct	*pop;
  int		p;
  tree		*t;
#endif
{
 int		j,tmp;
  float fit;


     fit = (float)dat.numtuple;
    for (j=0; j<dat.numtuple; j++) {
       current=j; 
       tmp=eval(t);
       if (tmp == dat.data[j][dat.numatt-1])
         {
            fit-=1.0; }
  }
    
    return (fit);
}




#ifdef ANSI_FUNC
float validate_fitness_of_treeTest(
     int	numpops,
     int	numgens,
     pop_struct *pop,
     int	p,
     tree 	*t
     )
#else

float validate_fitness_of_treeTest(numpops, numgens, pop, p, t)
  int		numpops;
  int		numgens;
  pop_struct	*pop;
  int		p;
  tree		*t;
#endif
{
 int		j,tmp;
  float fit;

  tmpdata = dat;
  dat = datt;  

     fit = (float)dat.numtuple;

    for (j=0; j<dat.numtuple; j++) {
       current=j; 
       tmp=eval(t);
       if (tmp == dat.data[j][dat.numatt-1])
         {
            fit=fit-1.0; }
  }
    fit += (float) count_crossover_pts(t)*pop[p].parsimony_factor;
    datt =dat; 
    dat = tmpdata;
  
    return (fit);
}


#ifdef ANSI_FUNC
void compute_confusion(
     int	numpops,
     int	numgens,
     pop_struct *pop,
     int	p,
     tree 	*t,
     Database dat
     )
#else

void compute_confusion(numpops, numgens, pop, p, t,dat)
  int		numpops;
  int		numgens;
  pop_struct	*pop;
  int		p;
  tree		*t;
  Database      dat;
#endif
{
 int		j,tmp;
 

    for (j=0; j<dat.numtuple; j++) {
       current=j; 
       tmp=eval(t);
       dat.confusion[dat.data[j][dat.numatt-1]][tmp]++;
  }
}


#ifdef ANSI_FUNC

int terminate_early(
  int 		numpops,
  int 		numgens,
  pop_struct 	*pop
  )
#else

int terminate_early(numpops,numgens,pop)
  int		numpops;
  int		numgens;
  pop_struct 	*pop;
#endif
{
  int	p,i,j;

   /*for (i=0; i<pop[p].width; i++)
    for (j=0;j<pop[p].height;j++)
 
   {
      if (pop[p].standardized_fitness[i][j] == 0.0) {
	return 1;
      }
    
  }*/
  return 0;
}
