

#include <stdio.h>
#include <malloc.h>
#include <errno.h>
#include "gpc.h"
#include "../CLASS/database.h"
#include <string.h>
#include <stdlib.h>
EXTERN char *nomefile;


#ifdef ANSI_FUNC

VOID pprint_tree_label_xml(
  pop_struct	*pop,
  tree 		*t,
  FILE          *f
  )
#else

VOID pprint_tree_label_xml(pop, t,f)
  pop_struct 	*pop;
  tree		*t,
  FILE          *f;
 
#endif
{
  int	i;
    
  if (t->nodetype == FUNCTION) {
    fprintf(f,"X%d [label=\"%s\"]\n",(int)t,function_printname(t));
    for (i=0; i<function_arity(t); i++) {
        pprint_tree_label(pop, t->type.func->arg[i],f);
      
    }
  } else if (t->nodetype == TERMINAL) {
    fprintf(f,"Xt%d [label=\"",(int)t);

    if (t->id == pop[t->pop].terminal_table_size) { 
      fprintf(f,"%f\"]\n", *(t->type.term->valptr));
    } else {
      fprintf(f,"%s\"]\n",terminal_printname(t));
    }
  } else {
    fprintf(stderr,
	    "nodetype %d must be %d or %d in pprint_tree() <treeio.c>\n",
	    t->nodetype, FUNCTION, TERMINAL);
  }
}


#ifdef ANSI_FUNC

VOID pprint_tree_xml(
  pop_struct	*pop,
  tree 		*t,
  char		*format,
  FILE 		*f,
  int 		level,
  Database 	dat
  )
#else

VOID pprint_tree_xml(pop, t, format, f, level,dat)
  pop_struct 	*pop;
  tree		*t;
  char		*format;
  FILE		*f;
  int		level;
  Database	dat;
#endif
{
  int	i,codice;
 
 

//blanks(level,f);
  if (t->nodetype == FUNCTION) {
     codice=t->id;
    
    for (i=0; i<function_arity(t); i++) {
     // blanks(level+1,f);
      // computing score if the child is terminal else score =""
    
    if (t->type.func->arg[i]->nodetype == TERMINAL) 
              fprintf(f,"<Node recordCount=\"5.0\" score=\"%s\">\n",terminal_printname(t->type.func->arg[i]));
    else
      	      fprintf(f,"<Node recordCount=\"5.0\" score=\"\">\n");
	      
         fprintf(f,"  <SimplePredicate field=\"%s\" value=\"%s\" operator=\"equal\"/>\n",function_printname(t),dat.listatt[codice].dominio[i]);
     // writng score distribution
   /* for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
     	    fprintf(f,"<ScoreDistribution value=\"%s\" recordCount=\"0.0\"/>\n",dat.listatt[dat.numatt-1].dominio[i]);      
      */
       if (t->type.func->arg[i]->nodetype == FUNCTION)
      		pprint_tree_xml(pop, t->type.func->arg[i], format, f, level+2*INDENT,dat);
     // blanks(level+1,f); 
         fprintf(f,"</Node>\n");
       
      }
     //blanks(level+1,f);

  } else if (t->nodetype == TERMINAL) {
    /*if (t->id == pop[t->pop].terminal_table_size) { 
      fprintf(f, format, *(t->type.term->valptr));
    } else {
    ;  fprintf(f,"<LEAF classification=\"%s\"/>\n",terminal_printname(t));
      
    }*/
  } else {
    fprintf(stderr,
	    "nodetype %d must be %d or %d in pprint_tree() <treeio.c>\n",
	    t->nodetype, FUNCTION, TERMINAL);
  }
  
  
}





#ifdef ANSI_FUNC

VOID write_tree_xml(
  pop_struct	*pop,
  tree 		*t,
  char		*format,
  FILE 		*f,
  Database	dat
  )
#else

VOID write_tree_xml(pop, t, format, f,dat)
  pop_struct 	*pop;
  tree		*t;
  char		*format;
  FILE		*f;
  Database	dat;
#endif
{
  char nome[60];
 int i,j;
 int incorrect, total;
 float perc;

fprintf(f,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<PMML version=\"2.1\">\n<Header copyright=\"Copyright (c) 2004 - Universita&apos; di Pisa, Dipartimento di Informatica - All Rights Reserved.\">\n<Application name=\"KDDML (Knowledge Discovery in Databases Markup Language)\" version=\"2.0\"/>\n</Header>\n");


// write schema xml on file
fprintf (f,"<DataDictionary numberOfFields=\"%d\">\n",dat.numatt);
for (i=0; i<dat.numatt;i++)
      {   
fprintf(f," <DataField name=\"%s\" optype=\"categorical\">\n",dat.listatt[i].nome);
          for (j=0;j<dat.listatt[i].numdominio;j++)
             fprintf(f," <Value value=\"%s\"/>\n",dat.listatt[i].dominio[j]);
	fprintf (f,"   </DataField>\n");
       }
fprintf (f,"</DataDictionary>\n");

// write tree
fprintf (f,"<TreeModel functionName=\"classification\" algorithmName=\"CAGE version 2.0\" modelName=\"weather_tree\" splitCharacteristic=\"multiSplit\">\n<MiningSchema>");
for (i=0; i<dat.numatt;i++)
      {   
      if (i==dat.numatt-1)
      		fprintf(f,"<MiningField name=\"%s\" usageType=\"predicted\"/>\n",dat.listatt[i].nome);
      else
		fprintf(f,"<MiningField name=\"%s\" usageType=\"active\"/>\n",dat.listatt[i].nome);
       }
fprintf (f,"</MiningSchema>\n");



// writng xml tree
// computing instances and errors
total=0;incorrect=0;
for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
        for (j=0;j<dat.listatt[dat.numatt-1].numdominio;j++)
   	{	  total+=dat.confusion[i][j];
	       if (i!=j)
	       		incorrect+=dat.confusion[i][j];
		 } 
perc = ((float)incorrect *100) /total; 


   // to correct
   fprintf(f, "<Node recordCount=\"%d\" score=\"\">\n<True/>\n",total);
    // to correct with a for
  /* fprintf(f,"<ScoreDistribution value=\"yes\" recordCount=\"7.0\"/>\n<ScoreDistribution value=\"no\" recordCount=\"5.0\"/>\n");*/
 pprint_tree_xml(pop, t, format, f, 0,dat);
fprintf(f, "</Node>\n");

// write confusion matrix
total=0;incorrect=0;
for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
        for (j=0;j<dat.listatt[dat.numatt-1].numdominio;j++)
   	{	  total+=dat.confusion[i][j];
	       if (i!=j)
	       		incorrect+=dat.confusion[i][j];
		 } 
perc = ((float)incorrect *100) /total; 

fprintf(f,"<Extension>\n<X-ConfusionMatrixTraining x-incorrectlyInst=\"%d\" x-totalInst=\"%d\" x-incorrectlyInstPerc=\"%.1f\">\n",incorrect,total,perc); 

fprintf(f,"<Array n=\"%d\" type=\"string\">",dat.listatt[dat.numatt-1].numdominio);
for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
      if (i<dat.listatt[dat.numatt-1].numdominio-1)
             fprintf(f,"\"%s\" ",dat.listatt[dat.numatt-1].dominio[i]); 
    else
        fprintf(f,"\"%s\"",dat.listatt[dat.numatt-1].dominio[i]); 
fprintf(f,"</Array>\n<Matrix kind=\"any\">\n");


for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
      {
      fprintf(f,"<Array n=\"%d\" type=\"real\">",dat.listatt[dat.numatt-1].numdominio);   
	//fprintf(f,"   <ROW name=\"%s\">\n",dat.listatt[dat.numatt-1].dominio[i]);
          for (j=0;j<dat.listatt[dat.numatt-1].numdominio;j++)
	     if (j<dat.listatt[dat.numatt-1].numdominio-1)
             	fprintf(f,"%d ",dat.confusion[i][j]);
	     else
	        fprintf(f,"%d",dat.confusion[i][j]);
fprintf (f,"</Array>\n"); 
       } 

fprintf(f," </Matrix>\n</X-ConfusionMatrixTraining>\n</Extension>\n</TreeModel>\n</PMML>"); 

/* fprintf(f,"digraph G\n  { \n \n");
  pprint_tree_xml(pop, t, format, f, 0,nome);
  pprint_tree_label_xml(pop,t,f);
 fprintf (f,"   }  \n");*/
}


