

#include <stdio.h>
#include <malloc.h>
#include <errno.h>
#include "gpc.h"
#include "../CLASS/database.h"
EXTERN char *nomefile;


#ifdef ANSI_FUNC

VOID pprint_tree_label_xml(
  pop_struct	*pop,
  tree 		*t,
  FILE          *f
  )
#else

VOID pprint_tree_label_xml(pop, t,f)
  pop_struct 	*pop;
  tree		*t,
  FILE          *f;
 
#endif
{
  int	i;
    
  if (t->nodetype == FUNCTION) {
    fprintf(f,"X%d [label=\"%s\"]\n",(int)t,function_printname(t));
    for (i=0; i<function_arity(t); i++) {
        pprint_tree_label(pop, t->type.func->arg[i],f);
      
    }
  } else if (t->nodetype == TERMINAL) {
    fprintf(f,"Xt%d [label=\"",(int)t);

    if (t->id == pop[t->pop].terminal_table_size) { 
      fprintf(f,"%f\"]\n", *(t->type.term->valptr));
    } else {
      fprintf(f,"%s\"]\n",terminal_printname(t));
    }
  } else {
    fprintf(stderr,
	    "nodetype %d must be %d or %d in pprint_tree() <treeio.c>\n",
	    t->nodetype, FUNCTION, TERMINAL);
  }
}


#ifdef ANSI_FUNC

VOID pprint_tree_xml(
  pop_struct	*pop,
  tree 		*t,
  char		*format,
  FILE 		*f,
  int 		level,
  Database 	dat
  )
#else

VOID pprint_tree_xml(pop, t, format, f, level,dat)
  pop_struct 	*pop;
  tree		*t;
  char		*format;
  FILE		*f;
  int		level;
  Database	dat;
#endif
{
  int	i,codice;
    
blanks(level,f);
  if (t->nodetype == FUNCTION) {
    fprintf(f,"<NODE attribute_name=\"%s\">\n",function_printname(t));
    codice=t->id;
    
    for (i=0; i<function_arity(t); i++) {
      blanks(level+1,f);
     fprintf(f,"<EDGE operator=\"=\" attribute_value=\"%s\">\n",dat.listatt[codice].dominio[i]);
      pprint_tree_xml(pop, t->type.func->arg[i], format, f, level+2*INDENT,dat);
      blanks(level+1,f); 
     fprintf(f,"</EDGE>\n");
      }
     blanks(level+1,f);
    fprintf(f,"</NODE>\n");
  } else if (t->nodetype == TERMINAL) {
    if (t->id == pop[t->pop].terminal_table_size) { /* a constant */
      fprintf(f, format, *(t->type.term->valptr));
    } else {
      fprintf(f,"<LEAF classification=\"%s\"/>\n",terminal_printname(t));
      
    }
  } else {
    fprintf(stderr,
	    "nodetype %d must be %d or %d in pprint_tree() <treeio.c>\n",
	    t->nodetype, FUNCTION, TERMINAL);
  }
  
}





#ifdef ANSI_FUNC

VOID write_tree_xml(
  pop_struct	*pop,
  tree 		*t,
  char		*format,
  FILE 		*f,
  Database	dat
  )
#else

VOID write_tree_xml(pop, t, format, f,dat)
  pop_struct 	*pop;
  tree		*t;
  char		*format;
  FILE		*f;
  Database	dat;
#endif
{
  char nome[60];
 int i,j;

fprintf(f,"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<!DOCTYPE KDDML_OBJECT SYSTEM \"../../environment/kddlang/kdd.dtd\" >\n<KDDML_OBJECT>\n");
fprintf (f,"<KDD_TREES class_att=\"%s\">\n",dat.listatt[dat.numatt-1].nome);


// write schema xml on file
fprintf (f,"<SCHEMA name=\"%s\">\n",nomefile);
for (i=0; i<dat.numatt;i++)
      {   
fprintf(f,"<ATTRIBUTE name=\"%s\">\n",dat.listatt[i].nome);
          for (j=0;j<dat.listatt[i].numdominio;j++)
             fprintf(f,"<ENUMERATED value=\"%s\"/>\n",dat.listatt[i].dominio[j]);
fprintf (f,"</ATTRIBUTE>\n"); 
       }
fprintf (f,"</SCHEMA>\n");

// write tree
 pprint_tree_xml(pop, t, format, f, 0,dat);
// write confusion matrix
fprintf(f,"<CONFUSION_MATRIX>\n"); 

for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
     fprintf(f," <ENUM name=\"%s\"/>\n",dat.listatt[dat.numatt-1].dominio[i]);        
for (i=0; i<dat.listatt[dat.numatt-1].numdominio;i++)
      {   
	fprintf(f,"   <ROW name=\"%s\">\n",dat.listatt[dat.numatt-1].dominio[i]);
          for (j=0;j<dat.listatt[dat.numatt-1].numdominio;j++)
             fprintf(f,"    <COLUMN value=\"%d\"/>\n",dat.confusion[i][j]);
fprintf (f,"   </ROW>\n"); 
       } 

fprintf(f,"</CONFUSION_MATRIX>\n"); 

fprintf(f,"</KDD_TREES>\n</KDDML_OBJECT>\n"); 

/* fprintf(f,"digraph G\n  { \n \n");
  pprint_tree_xml(pop, t, format, f, 0,nome);
  pprint_tree_label_xml(pop,t,f);
 fprintf (f,"   }  \n");*/
}


