<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<!-- 
PMML Version 2.0 HTML Association Model generator. 
-->



<xsl:template match="/">
  <html>
    <body  bgcolor="#E7F3F7">
      <h2><font color="#808080"><b>
      
      <TABLE width="100%" cellspacing="2" cellpadding="10" border="2">
      <TR>
         <TH align="left" width="100%">
            <FONT size="+1" color="black">
               <B>KDDML Association Rules Visualization</B>
            </FONT>
         </TH>
      </TR>
      </TABLE> 
      <BR d=""/>
      <BR d=""/>

      </b></font></h2>
      <left>
      <xsl:apply-templates select="PMML"/>
      </left>
    </body>
  </html>
</xsl:template>



<!-- This table identifies the application and model details -->
<xsl:template match="Header/Application">

   <HR/>
   <BR d=""/> 
   <b>
   <FONT size = "+1"> Software Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Software Used : <font color="blue">
		    <xsl:value-of select="@name" /> (version <xsl:value-of select="@version"/>)
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Copyright : <font color="blue">
		    <xsl:value-of select="/PMML/Header/@copyright" />
		    </font>
		                                         
	     </b>
			    
                </LI>
                <LI>
                        		    
	    <b>
		    Algorithm : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@algorithmName" /> 
		    </font>
	    </b>
	        </LI>
            </UL>
    <HR/>
    <BR d=""/>


   <b>
   <FONT size = "+1"> Model Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
		<LI>
		                        		    
	    <b>
		Model Name : <font color="blue">
		<xsl:value-of select="/PMML/AssociationModel/@modelName"/>
		</font>
	    </b>
			    
                </LI>
        	<LI>
        	        		    
	    <b>
		    Total Number of Items : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@numberOfItems" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Total Number of ItemSets : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@numberOfItemsets" /> 
		    </font>
	    </b>
	   
                </LI>
                <LI>
                        		    
	    <b>
		    Total Number of Rules : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@numberOfRules"/>
		    </font>
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Minumum Support : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@minimumSupport"/>
		    </font>
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Minimum Confidence : <font color="blue">
		    <xsl:value-of select="/PMML/AssociationModel/@minimumConfidence"/>
		    </font>
	    </b>
	    
                </LI>
                </UL>
    <HR/>
    <BR d=""/>
</xsl:template>



<!-- This table shows field meta data -->
<xsl:template match="DataDictionary">
  <b>
    <FONT size = "+1"> Metadata Information  </FONT>
  </b>
  <BR d=""/><BR d=""/>     
          	<UL>
  		<LI>
  		                        		    
  	    <b>
  		Number of Fields : <font color="blue">
  		<xsl:value-of select="@numberOfFields"/>
  		</font>
  	    </b>
  			    
                  </LI>
          	<LI>
          	        		    
  	    <b>
  		Number of Transactions : <font color="blue">
  		    <xsl:value-of select="/PMML/AssociationModel/@numberOfTransactions" />
  		    </font>
                                           
  	    </b>
  	    
                  </LI>
                   <LI>
	              	        		    
	      	    <b>
	      	Number of items contained in the largest transaction : <font color="blue">
	      		<xsl:value-of select="/PMML/AssociationModel/@maxNumberOfItemsPerTA" />
	      		</font>
	                                               
	      	    </b>
	      	    
                  </LI>
                   <LI>
	              	        		    
	      	    <b>
	      	Average number of items contained in a transaction : <font color="blue">
	      		<xsl:value-of select="/PMML/AssociationModel/@avgNumberOfItemsPerTA" />
	      		</font>
	                                               
	      	    </b>
	      	    
                  </LI>
            </UL>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Attributes Information </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Name</th>
    <th align="center" bgcolor="#FFCC66">Type</th>
    <th align="center" bgcolor="#FFCC66">Usage</th>
    <th align="center" bgcolor="#FFCC66">Values</th>
    </tr>
    
    <xsl:for-each select="DataField">
      <tr>
        <td align="center" bgcolor="#FFFFCC">
          <b> <xsl:value-of select="@name"/> </b>
        </td>  
        
        <td align="center" bgcolor="#FFFFCC">
          <xsl:value-of select="@optype"/>
        </td> 
        
        <td align="center" bgcolor="#FFFFCC">
           <xsl:for-each select="ancestor::PMML/AssociationModel/MiningSchema/MiningField[@name=current()/@name]">
              <xsl:value-of select="@usageType"/>
           </xsl:for-each>
        </td>       
     
        <td bgcolor="#FFFFCC" width="150">
        
          <xsl:if test="not(Value)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>         


         <xsl:if test="Value">
         <xsl:for-each select="Value">
           <xsl:value-of select="@value"/>&#160;
           <xsl:if test="not(position()=last())">
           <BR/>
           </xsl:if>
         </xsl:for-each>
         </xsl:if>        
                        
        </td>
         
      </tr>
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>


 
<xsl:template match="AssociationModel">
   
<!-- This table shows the Frequent Itemsets -->
  <HR/>
  <BR d=""/>
  <b>
     <FONT size = "+1"> Frequent Itemsets  </FONT>
       <BR d=""/>
   </b>
     <BR d=""/>
  <table width="100%" border="1">
    <tr bgcolor="#FF9933">
      <th colspan="12" align="center">Frequent Itemsets (ordered by support)</th>
    </tr>
    <tr bgcolor="#FFCC66">
      <th align="center">Id</th>
      <th align="center">Size</th>
      <th align="center">List of Items</th>
      <th align="center">Support % (absolute support)</th>      
     </tr> 
      <xsl:for-each select="Itemset">
      <xsl:sort select="@support" data-type="number" order="descending"/>
      <tr>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@id"/>
      </td>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@numberOfItems"/>
      </td>
      <td bgcolor="#FFFFCC">
      <xsl:for-each select="ItemRef">
        <xsl:for-each select="ancestor::AssociationModel/Item[@id=current()/@itemRef]">
            <xsl:value-of select="@value"/>&#160;
           <BR/>    
        </xsl:for-each>
      </xsl:for-each>
      </td>
      <td align="center" bgcolor="#FFFFCC">
      
      	     <xsl:if test="not(@support)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
      	     <xsl:if test="@support">
      	           <xsl:value-of select="substring(string(@support), 1, 5)"/>
	           (<xsl:value-of select="round((@support)*(/PMML/AssociationModel/@numberOfTransactions))"/> of
                   <xsl:value-of select="/PMML/AssociationModel/@numberOfTransactions"/>)
	     </xsl:if>	  
      </td>
      </tr>
      </xsl:for-each>
  </table>
    <BR d=""/>


<!-- This table shows the Association Rules -->
  <HR/>
  <BR d=""/>
  <b>
     <FONT size = "+1"> Association Rules  </FONT>
       <BR d=""/>
   </b>
     <BR d=""/>
  <table width="100%" border="1">
    <tr bgcolor="#FF9933">
      <th colspan="12" align="center">Association Rules (ordered by confidence)</th>
    </tr>
    <tr bgcolor="#FFCC66">
      <th align="center">Antecedent</th>
      <th align="center">--></th>
      <th align="center">Consequent</th>
      <th align="center">Support % (absolute support)</th>
      <th align="center">Confidence</th>

      
    </tr>
    <xsl:for-each select="AssociationRule">
    <xsl:sort select="@confidence" data-type="number" order="descending"/>
    
    <tr>

          <xsl:for-each select="ancestor::AssociationModel/Itemset[@id=current()/@antecedent]">
          <td bgcolor="#FFFFCC">
             <xsl:for-each select="ItemRef">
                <xsl:for-each select="ancestor::AssociationModel/Item[@id=current()/@itemRef]">
                <xsl:value-of select="@value"/>&#160;
		     <BR/>
                </xsl:for-each>
             </xsl:for-each>  
          </td>
          </xsl:for-each> 
     
          <td bgcolor="#FFFFCC" align="center">--></td>
          
          <xsl:for-each select="ancestor::AssociationModel/Itemset[@id=current()/@consequent]">
	       <td bgcolor="#FFFFCC">
	       <xsl:for-each select="ItemRef">
	            
	               <xsl:for-each select="ancestor::AssociationModel/Item[@id=current()/@itemRef]">
                <xsl:value-of select="@value"/>&#160;
		     <BR/>
	               </xsl:for-each>
	             
	        </xsl:for-each>  
	        </td>
          </xsl:for-each>
          
          <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="substring(string(@support), 1, 5)"/>
              (<xsl:value-of select="round ((@support)*(/PMML/AssociationModel/@numberOfTransactions))"/> of
               <xsl:value-of select="/PMML/AssociationModel/@numberOfTransactions"/>)
          </td>
          <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="substring(string(@confidence), 1, 5)"/></td>
            
                         
      </tr>      
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>



</xsl:stylesheet>