<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<!-- 
PMML Version 2.0 HTML Clustering Model generator. 
-->



<xsl:template match="/">
  <html>
    <body  bgcolor="#E7F3F7">
      <h2><font color="#808080"><b>
      
      <TABLE width="100%" cellspacing="2" cellpadding="10" border="2">
      <TR>
         <TH align="left" width="100%">
            <FONT size="+1" color="black">
               <B>KDDML Clustering Model Visualization</B>
            </FONT>
         </TH>
      </TR>
      </TABLE> 
      <BR d=""/>
      <BR d=""/>

      </b></font></h2>
      <left>
      <xsl:apply-templates select="PMML"/>
      </left>
    </body>
  </html>
</xsl:template>



<!-- This table identifies the application and model details -->
<xsl:template match="Header/Application">

   <HR/>
   <BR d=""/> 
   <b>
   <FONT size = "+1"> Software Information </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Software Used : <font color="blue">
		    <xsl:value-of select="@name" /> (version <xsl:value-of select="@version"/>)
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Copyright : <font color="blue">
		    <xsl:value-of select="/PMML/Header/@copyright" />
		    </font>
		                                         
	     </b>
			    
                </LI>
                <LI>
                        		    
	    <b>
		    Algorithm : <font color="blue">
		    <xsl:value-of select="/PMML/ClusteringModel/@algorithmName" /> 
		    </font>
	    </b>
	        </LI>
            </UL>
    <HR/>
    <BR d=""/>


   <b>
   <FONT size = "+1"> Model Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
		<LI>
		                        		    
	    <b>
		Model Name : <font color="blue">
		<xsl:value-of select="/PMML/ClusteringModel/@modelName"/>
		</font>
	    </b>
			    
                </LI>
        	<LI>
        	        		    
	    <b>
		    Number of Clusters : <font color="blue">
		    <xsl:value-of select="/PMML/ClusteringModel/@numberOfClusters" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Model Class : <font color="blue">
		    <xsl:value-of select="/PMML/ClusteringModel/@modelClass" /> 
		    </font>
	    </b>
	   
                </LI>
                </UL>
    <HR/>
    <BR d=""/>
</xsl:template>



<!-- This table shows field meta data -->
<xsl:template match="DataDictionary">
  <b>
    <FONT size = "+1"> Metadata Information  </FONT>
  </b>
  <BR d=""/><BR d=""/>     
          	<UL>
  		<LI>
  		                        		    
  	    <b>
  		Number of Fields : <font color="blue">
  		<xsl:value-of select="@numberOfFields"/>
  		</font>
  	    </b>
  			    
                  </LI>
            </UL>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Attributes Information </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Name</th>
    <th align="center" bgcolor="#FFCC66">Type</th>
    <th align="center" bgcolor="#FFCC66">Usage</th>
    <th align="center" bgcolor="#FFCC66">Values</th>
    </tr>
    
    <xsl:for-each select="DataField">
      <tr>
        <td align="center" bgcolor="#FFFFCC">
          <b> <xsl:value-of select="@name"/> </b>
        </td>  
        
        <td align="center" bgcolor="#FFFFCC">
          <xsl:value-of select="@optype"/>
        </td> 
        
        <td align="center" bgcolor="#FFFFCC">
           <xsl:for-each select="ancestor::PMML/ClusteringModel/MiningSchema/MiningField[@name=current()/@name]">
              <xsl:value-of select="@usageType"/>
           </xsl:for-each>
        </td>       
     
        <td bgcolor="#FFFFCC" width="150">
        
          <xsl:if test="not(Value)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>         


         <xsl:if test="Value">
         <xsl:for-each select="Value">
           <xsl:value-of select="@value"/>&#160;
           <xsl:if test="not(position()=last())">
           <BR/>
           </xsl:if>
         </xsl:for-each>
         </xsl:if>        
                        
        </td>
         
      </tr>
    </xsl:for-each>
  </table>
  <BR />
   <BR d=""/>
</xsl:template>


 
<xsl:template match="ClusteringModel">  
    <HR/>
    <BR d=""/>
  <b>
    <FONT size = "+1"> Clustering Description  </FONT>
  </b>
<BR d=""/>

<!-- This table shows the Univariate statistics -->
<xsl:for-each select="ModelStats">
    <table width="100%" border="1">
    <tr>  
    <th class="title" colspan="3">Cluster Details</th>
    </tr>
    <tr>
     <th class="property" colspan="3" align="center">Univariate Statistics</th>
    </tr>
    <tr>
     <th class="property" >Field</th>
     <th class="property" >Mean</th>
     <th class="property" >Standard Deviation</th>
    </tr>   
    <xsl:for-each select="UnivariateStats">
    <tr>
        <td width="100"><xsl:value-of select="@field"/></td>
        <td width="100"><xsl:value-of select="substring(NumericInfo/@mean,1,7)"/></td>
        <td width="100"><xsl:value-of select="substring(NumericInfo/@standardDeviation,1,5)"/></td>        
    </tr>
    </xsl:for-each>
    </table>
     <BR />    
</xsl:for-each>


<!-- This table shows the Univariate statistics -->

<xsl:if test="ClusteringField">

   <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Clustering Fields </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Field Name</th>
    <th align="center" bgcolor="#FFCC66">Compare Function</th>
    <th align="center" bgcolor="#FFCC66">Field Weight</th>
    <th align="center" bgcolor="#FFCC66">Similarity Scale</th>

    </tr>
    
    <xsl:for-each select="ClusteringField">
      <tr>
        <td align="center" bgcolor="#FFFFCC">
          <b> <xsl:value-of select="@field"/> </b>
        </td>  
 
        <td align="center" bgcolor="#FFFFCC">
			  <xsl:if test="not(@compareFunction)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
             <xsl:if test="@compareFunction"> 
                  <xsl:value-of select="@compareFunction"/> 
             </xsl:if>
        </td>
        
        <td align="center" bgcolor="#FFFFCC">
			  <xsl:if test="not(@fieldWeight)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
             <xsl:if test="@fieldWeight"> 
                  <xsl:value-of select="@fieldWeight"/> 
             </xsl:if>
        </td>  
        
        <td align="center" bgcolor="#FFFFCC">
			  <xsl:if test="not(@similarityScale)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
             <xsl:if test="@similarityScale"> 
                  <xsl:value-of select="@similarityScale"/> 
             </xsl:if>
        </td>  
      </tr>
    </xsl:for-each>
  </table>
  <BR /> 
  </xsl:if> 



<!-- This table shows the derived fields -->

<xsl:if test="CenterFields">

   <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Clustering Derived Fields (for seed coordinate) </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Field Name</th>
    <th align="center" bgcolor="#FFCC66">Category Value (for discrete fields)</th>
    <th align="center" bgcolor="#FFCC66">Normalization Values (Origin --> Norm) (for numeric fields)</th>
    </tr>
    
    <xsl:for-each select="CenterFields/DerivedField">
    <xsl:if test="NormDiscrete">
      <tr>
        <td align="center" bgcolor="#FFFFCC"><b><xsl:value-of select="NormDiscrete/@field"/></b></td>
        <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="NormDiscrete/@value"/></td>        
        <td align="center" bgcolor="#FFFFCC"><xsl:text>n/a</xsl:text></td> 
      </tr>
      </xsl:if> 
      
     <xsl:if test="NormContinuous">
      <tr>
        <td align="center" bgcolor="#FFFFCC"><b><xsl:value-of select="NormContinuous/@field"/></b></td>
        <td align="center" bgcolor="#FFFFCC"><xsl:text>n/a</xsl:text></td>       
       <td align="center" bgcolor="#FFFFCC"><xsl:for-each select="NormContinuous/LinearNorm">
             <xsl:value-of select="@orig"/> ---> 
             <xsl:value-of select="@norm"/> <BR/>
             </xsl:for-each>
       </td>
      </tr>
      </xsl:if> 
    </xsl:for-each>
  </table>
    <BR />
</xsl:if>


<!-- This table shows the Clusters -->

    <HR/>
    <BR d=""/>
  <b>
    <FONT size = "+1"> Clusters Description  </FONT>
  </b>
<BR d=""/>
<BR d=""/>
  <table width="100%" border="1">
   <tr>  
    <th colspan="12" bgcolor="#FF9933"> Clusters </th>
    </tr>
    <tr>
     <th align="center" bgcolor="#FFCC66">Cluster Name</th>
     <th align="center" bgcolor="#FFCC66">Seed Coordinate</th>
     <th align="center" bgcolor="#FFCC66">Partition Information</th>
    </tr>
  
  <xsl:for-each select="Cluster">
    <tr>
     <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="@name"/></td>
     <td align="center" bgcolor="#FFFFCC"><xsl:apply-templates select="Array"/></td>
  
  <td>
  <xsl:if test="not(Partition)"> 
      		 <xsl:text>n/a</xsl:text>
  </xsl:if>
  <xsl:if test="Partition">
        <table width="100%" border="1">
        
        <tr>
        <th align="center" bgcolor="#FFCC66">Field Name</th>
       <th align="center" bgcolor="#FFCC66">Field Category Value</th>
       <th align="center" bgcolor="#FFCC66">Field Category Cardinality</th>
       <th align="center" bgcolor="#FFCC66">Mean</th>
       <th align="center" bgcolor="#FFCC66">Variance</th>
        </tr>       
       <xsl:for-each select="Partition/PartitionFieldStats">
       
         <tr>
         <td align="center" bgcolor="#FFFFCC">
              <xsl:value-of select="@field"/></td>
         <td align="center" bgcolor="#FFFFCC">
           <xsl:for-each select="ancestor::PMML/DataDictionary/DataField[@name=current()/@field]">
           
		    <xsl:if test="not(Value)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
            
            <xsl:if test="Value"> 
           <xsl:for-each select="Value">
           <xsl:value-of select="@value"/><BR />
           </xsl:for-each>
           </xsl:if>
           </xsl:for-each>
           </td>

         <td align="center" bgcolor="#FFFFCC">
             <xsl:if test="not(Array)"> 
      		       <xsl:text>n/a</xsl:text>
      	    </xsl:if>
      	    <xsl:if test="Array"> 
                  <xsl:apply-templates select="Array"/>
             </xsl:if>
         </td>
         
         <td align="center" bgcolor="#FFFFCC">
              <xsl:if test="not(NumericInfo/@mean)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
      	     <xsl:if test="NumericInfo/@mean"> 
      		       <xsl:value-of select="NumericInfo/@mean"/>
      	     </xsl:if>             
         </td>
         
         <td align="center" bgcolor="#FFFFCC">
              <xsl:if test="not(NumericInfo/@standardDeviation)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
      	     <xsl:if test="NumericInfo/@standardDeviation"> 
      		       <xsl:value-of select="NumericInfo/@standardDeviation"/>
      	     </xsl:if> 
         </td>  
        </tr>
       </xsl:for-each>    
        </table>
  </xsl:if>
  </td>
    </tr>
</xsl:for-each> 
</table>

</xsl:template>
    



<!-- This allows us the read the 'Array' tag, which contains spaces within a single tag value -->
<xsl:template match="Array">
  <xsl:call-template name="write-array">
    <xsl:with-param name="string" select="."/>
  </xsl:call-template>
</xsl:template>
 
<xsl:template name="write-array">
  <xsl:param name="string"/>
  <xsl:choose>
    <xsl:when test="contains($string,' ')">
      <!-- there are still spaces, so write the first token, a new line, and then
             call the template again with the remaining string -->
      <xsl:value-of select="substring-before($string, ' ')"/>
      <BR d=""/>
      <!-- call the template with the remainder of the string -->
      <xsl:call-template name="write-array">
          <xsl:with-param name="string" select="substring-after($string,' ')"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
       <!-- no more spaces, so just write the last token and quit -->
       <xsl:value-of select="$string"/>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


</xsl:stylesheet>