<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet 
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="1.0">
  <xsl:param name="file_xml" select="'default value'"/>
  <xsl:param name="data_file" select="'default value'"/>
  <xsl:param name="pp_data_file" select="'default value'"/>
		<xsl:output method="html"/>

<!-- 
    Regola per l'elemento radice.
-->
<xsl:template match="KDDML_OBJECT">
  <html>
      
    <body  bgcolor="#E7F3F7">
    
    
      <h2><font color="#808080"><b>
      
      
      <TABLE width="100%" cellspacing="2" cellpadding="10" border="2">
      <TR>
          <TH align="left" width="100%">
          <FONT size="+1" color="black">
              <B>KDDML Table Visualization</B>
          </FONT>
          </TH>
      </TR>
      </TABLE> 
      <BR d=""/>
      
      </b></font></h2>
      
      
      <HR/>
      <BR d=""/> 
      <b>
         <FONT size = "+1"> Schema Information  </FONT>
      </b>
      <BR d=""/><BR d=""/>     
         <UL>
         <LI>
              	        		    
      	    <b>
      		    Logical Name : <font color="blue">
      		    <xsl:value-of select="KDDML_TABLE/SCHEMA/@logical_name" />
      		    </font>
                                               
      	    </b>
      	    
         </LI>
         <LI>
	 	                                		    
	     <b>
	 	            XML Reference : <font color="blue">
	 	        	<a href="{$file_xml}">
	       			<xsl:value-of select="$file_xml"/>  
	 			</a> 
	 	        		    </font>
	     </b>
      	 </LI>
         <LI>
      		        	        		    
      	     <b>
      		    Total Number of Attributes : <font color="blue">
      		    <xsl:value-of select="KDDML_TABLE/SCHEMA/@number_of_attributes" />
      		    </font>
      		                                         
      	     </b>
      			    
         </LI>
         <LI>
                              		    
      	    <b>
      		    Total Number of Instances : <font color="blue">
      		    <xsl:value-of select="KDDML_TABLE/SCHEMA/@number_of_instances" /> 
      		    </font>
      	    </b>
      	  </LI>
          </UL>
          <HR/>
    <BR d=""/>
    <b>
             <FONT size = "+1"> Attribute Information  </FONT>
    </b>
    <BR d=""/>
    <BR d=""/>
    <xsl:apply-templates select="KDDML_TABLE/SCHEMA"/>
    <BR d=""/>    
    
    <BR d=""/>
    <xsl:apply-templates select="KDDML_TABLE/PPSCHEMA"/>

    <BR d=""/>
    <xsl:apply-templates select="KDDML_TABLE/PPSCHEMA/HISTORY"/>
    <BR d=""/>   
          <HR/>
          <BR d=""/> 
          <b>
             <FONT size = "+1"> Physical Instances  </FONT>
          </b>
          <BR d=""/><BR d=""/>     
             <UL>
             <LI>
                  	        		    
          	    <b>
          		    Data :
          		    <a href="{$data_file}">
			                		<xsl:value-of select="$data_file"/>  
			    			</a>
			    	<BR/>
	            </b>
	            </LI>
	            <BR/>
	            <LI>
	            <b>
	            
			    Preprocessing Metadata : 
			    
			    <xsl:if test="$pp_data_file != 'default value'">
			          		        <a href="{$pp_data_file}">
			          			<xsl:value-of select="$pp_data_file"/>  
			    			</a>
			    			<BR/>
			    			
		</xsl:if>
                                                   
          	    </b>
          	    
             </LI>
              </UL>
          <HR/>
    
    </body>
  </html>
<TITLE>Output Table</TITLE>
</xsl:template>


<!-- 
    Regola per l'elemento SCHEMA.
-->
<xsl:template match="SCHEMA">
  <table width="100%" border="1">
    <tr>  
    <th colspan="8" bgcolor="#FF9933">Attribute Info</th>
    </tr>
    <tr>
    <th bgcolor="#FFCC66">Field Name</th>
    <th bgcolor="#FFCC66">Type</th>
    <th bgcolor="#FFCC66">Missed Values (%)</th>
    <th bgcolor="#FFCC66">Values: Cardinality (%)</th>
    <th bgcolor="#FFCC66">Mean</th>
    <th bgcolor="#FFCC66">Variance</th>
    <th bgcolor="#FFCC66">Min Value</th>
    <th bgcolor="#FFCC66">Max Value</th>
    </tr>
    
    <xsl:for-each select="ATTRIBUTE">
      <tr>
        <td bgcolor="#FFFFCC" width="150"><b><xsl:value-of select="@name"/></b></td>
        
        <td bgcolor="#FFFFCC" width="150"><xsl:value-of select="@type"/></td>
                    
        <td bgcolor="#FFFFCC" width="150">
		<xsl:value-of select="@number_of_missed_values"/>
		(<xsl:value-of select="@number_of_missed_values_perc"/>)
        </td>
                    
        <td bgcolor="#FFFFCC" width="150">
            <xsl:if test="not(NOMINAL_DESCRIPTION)">
                  <xsl:text>n/a</xsl:text>
             </xsl:if>
             <xsl:if test="NOMINAL_DESCRIPTION">
                <xsl:apply-templates select="NOMINAL_DESCRIPTION"/>      
             </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
          <xsl:if test="not(NUMERIC_DESCRIPTION/@mean)"> 
	             <xsl:text>n/a</xsl:text>
          </xsl:if>
          <xsl:if test="NUMERIC_DESCRIPTION/@mean">
        <xsl:value-of select="NUMERIC_DESCRIPTION/@mean"/>
        </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	   <xsl:if test="not(NUMERIC_DESCRIPTION/@variance)"> 
		      <xsl:text>n/a</xsl:text>
	   </xsl:if>
	   <xsl:if test="NUMERIC_DESCRIPTION/@variance">
	<xsl:value-of select="NUMERIC_DESCRIPTION/@variance"/>
	</xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	     <xsl:if test="not(NUMERIC_DESCRIPTION/@min)"> 
		       <xsl:text>n/a</xsl:text>
	     </xsl:if>
	     <xsl:if test="NUMERIC_DESCRIPTION/@min">
	        <xsl:value-of select="NUMERIC_DESCRIPTION/@min"/>
	     </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	     <xsl:if test="not(NUMERIC_DESCRIPTION/@max)"> 
		       <xsl:text>n/a</xsl:text>
	     </xsl:if>
	     <xsl:if test="NUMERIC_DESCRIPTION/@max">
	        <xsl:value-of select="NUMERIC_DESCRIPTION/@max"/>
	     </xsl:if>
        </td>
        
      </tr>
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>



<!--
    Regola per l'elemento NOMINAL_DESCRIPTION.
-->
<xsl:template match="NOMINAL_DESCRIPTION">
    <xsl:if test="not(VALUE)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>
          <xsl:if test="VALUE">
             <xsl:for-each select="VALUE">
               <xsl:value-of select="@value"/>:
               <xsl:value-of select="@cardinality"/>
               (<xsl:value-of select="@cardinality_perc"/>)
               <xsl:if test="not(position()=last())">
                 <BR/>
               </xsl:if>
             </xsl:for-each>
    </xsl:if>
</xsl:template>




  
 
<!-- 
    Regola per l'elemento PPSCHEMA.
-->
<xsl:template match="PPSCHEMA">
    <b>
             <FONT size = "+1"> Metadata Attribute Information  </FONT>
    </b>
    <BR d=""/>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="8" bgcolor="#FF9933">Attribute Info</th>
    </tr>
    <tr>
    <th bgcolor="#FFCC66">Field Name</th>
    <th bgcolor="#FFCC66">Type</th>
    <th bgcolor="#FFCC66">Missed Values (%)</th>
    <th bgcolor="#FFCC66">Values: Cardinality (%)</th>
    <th bgcolor="#FFCC66">Mean</th>
    <th bgcolor="#FFCC66">Variance</th>
    <th bgcolor="#FFCC66">Min Value</th>
    <th bgcolor="#FFCC66">Max Value</th>
    </tr>
    
    <xsl:for-each select="ATTRIBUTE">
      <tr>
        <td bgcolor="#FFFFCC" width="150"><b><xsl:value-of select="@name"/></b></td>
        
        <td bgcolor="#FFFFCC" width="150"><xsl:value-of select="@type"/></td>
                    
        <td bgcolor="#FFFFCC" width="150">
		<xsl:value-of select="@number_of_missed_values"/>
		(<xsl:value-of select="@number_of_missed_values_perc"/>)
        </td>
                    
        <td bgcolor="#FFFFCC" width="150">
            <xsl:if test="not(NOMINAL_DESCRIPTION)">
                  <xsl:text>n/a</xsl:text>
             </xsl:if>
             <xsl:if test="NOMINAL_DESCRIPTION">
                <xsl:apply-templates select="NOMINAL_DESCRIPTION"/>      
             </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
          <xsl:if test="not(NUMERIC_DESCRIPTION/@mean)"> 
	             <xsl:text>n/a</xsl:text>
          </xsl:if>
          <xsl:if test="NUMERIC_DESCRIPTION/@mean">
        <xsl:value-of select="NUMERIC_DESCRIPTION/@mean"/>
        </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	   <xsl:if test="not(NUMERIC_DESCRIPTION/@variance)"> 
		      <xsl:text>n/a</xsl:text>
	   </xsl:if>
	   <xsl:if test="NUMERIC_DESCRIPTION/@variance">
	<xsl:value-of select="NUMERIC_DESCRIPTION/@variance"/>
	</xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	     <xsl:if test="not(NUMERIC_DESCRIPTION/@min)"> 
		       <xsl:text>n/a</xsl:text>
	     </xsl:if>
	     <xsl:if test="NUMERIC_DESCRIPTION/@min">
	        <xsl:value-of select="NUMERIC_DESCRIPTION/@min"/>
	     </xsl:if>
        </td>
        
        <td bgcolor="#FFFFCC" width="150">
	     <xsl:if test="not(NUMERIC_DESCRIPTION/@max)"> 
		       <xsl:text>n/a</xsl:text>
	     </xsl:if>
	     <xsl:if test="NUMERIC_DESCRIPTION/@max">
	        <xsl:value-of select="NUMERIC_DESCRIPTION/@max"/>
	     </xsl:if>
        </td>
        
      </tr>
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>



<!--
    Regola per l'elemento NOMINAL_DESCRIPTION.
-->
<xsl:template match="NOMINAL_DESCRIPTION">
    <xsl:if test="not(VALUE)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>
          <xsl:if test="VALUE">
             <xsl:for-each select="VALUE">
               <xsl:value-of select="@value"/>:
               <xsl:value-of select="@cardinality"/>
               (<xsl:value-of select="@cardinality_perc"/>)
               <xsl:if test="not(position()=last())">
                 <BR/>
               </xsl:if>
             </xsl:for-each>
    </xsl:if>
  <BR />
</xsl:template>




  



<!-- 
    Regola per l'elemento HISTORY.
-->
<xsl:template match="HISTORY">
    <BR d=""/>   
<b>
             <FONT size = "+1"> History  </FONT>
    </b>
    <BR d=""/>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="6" bgcolor="#FF9933">Preprocessing operations</th>
    </tr>
    <tr>
    <th bgcolor="#FFCC66">Operation</th>
    <th bgcolor="#FFCC66">Description</th>
    
    </tr>
    
    <xsl:for-each select="PREPROCESSING_TASK">
      <tr>
        <td bgcolor="#FFFFCC" width="150"><b><xsl:value-of select="@operation_name"/></b></td>
        
        <td bgcolor="#FFFFCC" width="150"><xsl:value-of select="@description"/></td>
  
      </tr>
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>
</xsl:stylesheet>



