<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<!-- 
PMML Version 2.0 HTML Sequence Model generator. 
-->


<xsl:template match="/">
  <html>
    <body  bgcolor="#E7F3F7">
      <h2><font color="#808080"><b>
      
      <TABLE width="100%" cellspacing="2" cellpadding="10" border="2">
      <TR>
         <TH align="left" width="100%">
            <FONT size="+1" color="black">
               <B>PMML Sequential Patterns Visualization</B>
            </FONT>
         </TH>
      </TR>
      </TABLE> 
      <BR d=""/>
      <BR d=""/>

      </b></font></h2>
      <left>
      <xsl:apply-templates select="PMML"/>
      </left>
    </body>
  </html>
</xsl:template>



<!-- This table identifies the application and model details -->
<xsl:template match="Header/Application">

   <HR/>
   <BR d=""/> 
   <b>
   <FONT size = "+1"> Software Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Software Used : <font color="blue">
		    <xsl:value-of select="@name" /> (version <xsl:value-of select="@version"/>)
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Copyright : <font color="blue">
		    <xsl:value-of select="/PMML/Header/@copyright" />
		    </font>
		                                         
	     </b>
			    
                </LI>
                <LI>
                        		    
	    <b>
		    Algorithm : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@algorithmName" /> 
		    </font>
	    </b>
	        </LI>
            </UL>
    <HR/>
    <BR d=""/>



  <b>
   <FONT size = "+1"> Model Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
		<LI>
		                        		    
	    <b>
		Model Name : <font color="blue">
		<xsl:value-of select="/PMML/SequenceModel/@modelName"/>
		</font>
	    </b>
			    
                </LI>
        	<LI>
        	        		    
	    <b>
		    Total Number of Items : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@numberOfItems" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Total Number of Sets : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@numberOfSets" /> 
		    </font>
	    </b>
	   
                </LI>
                <LI>
                        		    
	    <b>
		    Total Number of Sequencess : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@numberOfSequences" /> 
		    </font>
	    </b>
	   
                </LI>
                <LI>
                        		    
	    <b>
		    Total Number of Rules : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@numberOfRules"/>
		    </font>
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Minumum Support : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@minimumSupport"/>
		    </font>
	    </b>
	    
                </LI>
                <LI>
                        		    
	    <b>
		    Minimum Confidence : <font color="blue">
		    <xsl:value-of select="/PMML/SequenceModel/@minimumConfidence"/>
		    </font>
	    </b>
	    
                </LI>
                </UL>
    <HR/>
    <BR d=""/>
</xsl:template>   



<!-- This table shows field meta data -->
<xsl:template match="DataDictionary">
  <b>
    <FONT size = "+1"> Metadata Information  </FONT>
  </b>
  <BR d=""/><BR d=""/>     
          	<UL>
  		<LI>
  		                        		    
  	    <b>
  		Number of Fields : <font color="blue">
  		<xsl:value-of select="@numberOfFields"/>
  		</font>
  	    </b>
  			    
                  </LI>
          	<LI>
          	        		    
  	    <b>
  		Number of Transactions : <font color="blue">
  		    <xsl:value-of select="/PMML/SequenceModel/@numberOfTransactions" />
  		    </font>
                                           
  	    </b>
  	    
                  </LI>
                   <LI>
	              	        		    
	      	    <b>
	      	Number of items contained in the largest transaction : <font color="blue">
	      		<xsl:value-of select="/PMML/SequenceModel/@maxNumberOfItemsPerTransaction" />
	      		</font>
	                                               
	      	    </b>
	      	    
                  </LI>
                   <LI>
	              	        		    
	      	    <b>
	      	Average number of items contained in a transaction : <font color="blue">
	      		<xsl:value-of select="/PMML/SequenceModel/@avgNumberOfItemsPerTransaction" />
	      		</font>
	                                               
	      	    </b>
	      	    
                  </LI>
            </UL>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Attributes Information </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Name</th>
    <th align="center" bgcolor="#FFCC66">Type</th>
    <th align="center" bgcolor="#FFCC66">Usage</th>
    <th align="center" bgcolor="#FFCC66">Values</th>
    </tr>
    
    <xsl:for-each select="DataField">
      <tr>
        <td align="center" bgcolor="#FFFFCC">
          <b> <xsl:value-of select="@name"/> </b>
        </td>  
        
        <td align="center" bgcolor="#FFFFCC">
          <xsl:value-of select="@optype"/>
        </td> 
        
        <td align="center" bgcolor="#FFFFCC">
           <xsl:for-each select="ancestor::PMML/SequenceModel/MiningSchema/MiningField[@name=current()/@name]">
              <xsl:value-of select="@usageType"/>
           </xsl:for-each>
        </td>       
     
        <td bgcolor="#FFFFCC" width="150">
        
          <xsl:if test="not(Value)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>         


         <xsl:if test="Value">
         <xsl:for-each select="Value">
           <xsl:value-of select="@value"/>&#160;
           <xsl:if test="not(position()=last())">
           <BR/>
           </xsl:if>
         </xsl:for-each>
         </xsl:if>        
                        
        </td>
         
      </tr>
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>


<xsl:template match="SequenceModel">
   
<!-- This table shows the Frequent Sequences -->
  <HR/>
  <BR d=""/>
  <b>
     <FONT size = "+1"> Frequent Sequences  </FONT>
       <BR d=""/>
   </b>
     <BR d=""/>
  <table width="100%" border="1">
    <tr bgcolor="#FF9933">
      <th colspan="12" align="center">Frequent Sequences (ordered by support)</th>
    </tr>
    <tr bgcolor="#FFCC66">
      <th align="center">Id</th>
      <th align="center">Number Of Sets</th>
      <th align="center">List of Sets</th>
      <th align="center">Support % (absolute support)</th>      
     </tr> 
      <xsl:for-each select="Sequence">
      <xsl:sort select="@support" data-type="number" order="descending"/>
      <tr>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@id"/>
      </td>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@numberOfSets"/>
      </td>
      <td bgcolor="#FFFFCC">
      
      <!-- Itemset -->
      <xsl:for-each select="SetReference">
        <xsl:for-each select="ancestor::SequenceModel/Itemset[@id=current()/@setId]">
            (
            <xsl:for-each select="ItemRef">	
            	<xsl:for-each select="ancestor::SequenceModel/Item[@id=current()/@itemRef]">
            		<xsl:value-of select="@value"/>,&#160;
           	</xsl:for-each>
           </xsl:for-each>
           )
           <!--BR/-->    
        </xsl:for-each>
      </xsl:for-each>
      
      <!-- SetPredicate -->
      <xsl:for-each select="SetReference">
        <xsl:for-each select="ancestor::SequenceModel/SetPredicate[@id=current()/@setId]">
            (
            <xsl:for-each select="Array">	          
            		<xsl:value-of select="."/>,&#160;
           </xsl:for-each>
           )
           <!--BR/-->    
        </xsl:for-each>
      </xsl:for-each>
      
      </td>
      <td align="center" bgcolor="#FFFFCC">
      
      	     <xsl:if test="not(@support)"> 
      		       <xsl:text>n/a</xsl:text>
      	     </xsl:if>
      	     <xsl:if test="@support">
      	           <xsl:value-of select="substring(string(@support), 1, 5)"/>
	           (<xsl:value-of select="round((@support)div(100)*(/PMML/SequenceModel/@numberOfTransactions))"/> of
                   <xsl:value-of select="/PMML/SequenceModel/@numberOfTransactions"/>)
	     </xsl:if>	  
      </td>
      </tr>
      </xsl:for-each>
  </table>
    <BR d=""/>


<!-- This table shows the Sequence Rules -->
  <HR/>
  <BR d=""/>
  <b>
     <FONT size = "+1"> Sequence Rules  </FONT>
       <BR d=""/>
   </b>
     <BR d=""/>
  <table width="100%" border="1">
    <tr bgcolor="#FF9933">
      <th colspan="12" align="center">Sequence Rules (ordered by confidence)</th>
    </tr>
    <tr bgcolor="#FFCC66">
      <th align="center">Id</th>
      <th align="center">Number Of Sets</th>
      <th align="center">Antecedent</th>
      <th align="center">--&gt;</th>
      <th align="center">Consequent</th>
      <th align="center">Support % (absolute support)</th>
      <th align="center">Confidence</th>

      
    </tr>
    <xsl:for-each select="SequenceRule">
    <xsl:sort select="@confidence" data-type="number" order="descending"/>
    
    <tr>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@id"/>
      </td>
      <td align="center" bgcolor="#FFFFCC">
            <xsl:value-of select="@numberOfSets"/>
      </td>


	<xsl:for-each select="AntecedentSequence/SequenceReference">
          <xsl:for-each select="ancestor::SequenceModel/Sequence[@id=current()/@seqId]">
	  	<td bgcolor="#FFFFCC">

		      <!-- Itemset -->
		      <xsl:for-each select="SetReference">			
			<xsl:for-each select="ancestor::SequenceModel/Itemset[@id=current()/@setId]">
			   (
			   <xsl:for-each select="ItemRef">	
				<xsl:for-each select="ancestor::SequenceModel/Item[@id=current()/@itemRef]">
					<xsl:value-of select="@value"/>,&#160;
				</xsl:for-each>
			   </xsl:for-each>
			   )
			   <!--BR/-->    
			</xsl:for-each>
		      </xsl:for-each>

      		      <!-- SetPredicate -->
		      <xsl:for-each select="SetReference">
			<xsl:for-each select="ancestor::SequenceModel/SetPredicate[@id=current()/@setId]">
			   (
			   <xsl:for-each select="Array">	          
					<xsl:value-of select="."/>,&#160;
			   </xsl:for-each>
			   )
			   <!--BR/-->    
			</xsl:for-each>
		      </xsl:for-each>
		      		      
		</td>
          </xsl:for-each> 
        </xsl:for-each>
     
        <td bgcolor="#FFFFCC" align="center">--&gt;</td>
          
	<xsl:for-each select="ConsequentSequence/SequenceReference">
          <xsl:for-each select="ancestor::SequenceModel/Sequence[@id=current()/@seqId]">
	  	<td bgcolor="#FFFFCC">

		      <!-- Itemset -->		      	  	
		      <xsl:for-each select="SetReference">
			<xsl:for-each select="ancestor::SequenceModel/Itemset[@id=current()/@setId]">
			    (
			    <xsl:for-each select="ItemRef">	
				<xsl:for-each select="ancestor::SequenceModel/Item[@id=current()/@itemRef]">
					<xsl:value-of select="@value"/>,&#160;        
				</xsl:for-each>
			   </xsl:for-each>
			   )
			   <!--BR/-->    
			</xsl:for-each>
		      </xsl:for-each>

		      <!-- SetPredicate -->		      
		      <xsl:for-each select="SetReference">
			<xsl:for-each select="ancestor::SequenceModel/SetPredicate[@id=current()/@setId]">
			   (
			   <xsl:for-each select="Array">	          
					<xsl:value-of select="."/>,&#160;        
			   </xsl:for-each>
			   )
			   <!--BR/-->    
			</xsl:for-each>
		      </xsl:for-each>		      
		      
		</td>

          </xsl:for-each> 
        </xsl:for-each>
          
          <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="substring(string(@support), 1, 5)"/>
              (<xsl:value-of select="round((@support)div(100)*(/PMML/SequenceModel/@numberOfTransactions))"/> of
               <xsl:value-of select="/PMML/SequenceModel/@numberOfTransactions"/>)
          </td>
          <td align="center" bgcolor="#FFFFCC"><xsl:value-of select="substring(string(@confidence), 1, 5)"/></td>
            
                         
      </tr>      
    </xsl:for-each>
  </table>
  <BR />
</xsl:template>


</xsl:stylesheet>