<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html"/>

<!-- 
PMML Version 2.0 HTML Classification Tree Model generator. 
-->



<xsl:template match="/">
  <html>
    <body  bgcolor="#E7F3F7">
      <h2><font color="#808080"><b>
      
      <TABLE width="100%" cellspacing="2" cellpadding="10" border="2">
      <TR>
         <TH align="left" width="100%">
            <FONT size="+1" color="black">
               <B>KDDML Classification Tree Model Visualization</B>
            </FONT>
         </TH>
      </TR>
      </TABLE> 
      <BR d=""/>
      <BR d=""/>

      </b></font></h2>
      <left>
      <xsl:apply-templates select="PMML"/>
      </left>
    </body>
  </html>
</xsl:template>



<!-- This table identifies the application and model details -->
<xsl:template match="Header/Application">

   <HR/>
   <BR d=""/> 
   <b>
   <FONT size = "+1"> Software Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Software Used : <font color="blue">
		    <xsl:value-of select="@name" /> (version <xsl:value-of select="@version"/>)
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Copyright : <font color="blue">
		    <xsl:value-of select="/PMML/Header/@copyright" />
		    </font>
		                                         
	     </b>
			    
                </LI>
                <LI>
                        		    
	    <b>
		    Algorithm : <font color="blue">
		    <xsl:value-of select="/PMML/TreeModel/@algorithmName" /> 
		    </font>
	    </b>
	        </LI>
            </UL>
    <HR/>
    <BR d=""/>


   <b>
   <FONT size = "+1"> Model Information  </FONT>
   </b>
   <BR d=""/><BR d=""/>     
        	<UL>
		<LI>
		                        		    
	    <b>
		Model Name : <font color="blue">
		<xsl:value-of select="/PMML/TreeModel/@modelName"/>
		</font>
	    </b>
			    
                </LI>
        	<LI>
        	        		    
	    <b>
		    Node Splitting : <font color="blue">
		    <xsl:value-of select="/PMML/TreeModel/@splitCharacteristic" />
		    </font>
                                         
	    </b>
	    
                </LI>
                </UL>
    <HR/>
    <BR d=""/>
</xsl:template>



<!-- This table shows field meta data -->
<xsl:template match="DataDictionary">
  <b>
    <FONT size = "+1"> Metadata Information  </FONT>
  </b>
  <BR d=""/><BR d=""/>     
          	<UL>
  		<LI>
  		                        		    
  	    <b>
  		Number of Fields : <font color="blue">
  		<xsl:value-of select="@numberOfFields"/>
  		</font>
  	    </b>
  			    
                  </LI>
            </UL>
    <BR d=""/>
  <table width="100%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Attributes Information </th>
    </tr>
    <tr>
    <th align="center" bgcolor="#FFCC66">Name</th>
    <th align="center" bgcolor="#FFCC66">Type</th>
    <th align="center" bgcolor="#FFCC66">Usage</th>
    <th align="center" bgcolor="#FFCC66">Values</th>
    </tr>
    
    <xsl:for-each select="DataField">
      <tr>
        <td align="center" bgcolor="#FFFFCC">
          <b> <xsl:value-of select="@name"/> </b>
        </td>  
        
        <td align="center" bgcolor="#FFFFCC">
          <xsl:value-of select="@optype"/>
        </td> 
        
        <td align="center" bgcolor="#FFFFCC">
           <xsl:for-each select="ancestor::PMML/TreeModel/MiningSchema/MiningField[@name=current()/@name]">
              <xsl:value-of select="@usageType"/>
           </xsl:for-each>
        </td>       
     
        <td bgcolor="#FFFFCC" width="150">
        
          <xsl:if test="not(Value)"> 
             <xsl:text>n/a</xsl:text>
          </xsl:if>         


         <xsl:if test="Value">
         <xsl:for-each select="Value">
           <xsl:value-of select="@value"/>&#160;
           <xsl:if test="not(position()=last())">
           <BR/>
           </xsl:if>
         </xsl:for-each>
         </xsl:if>        
                        
        </td>
         
      </tr>
    </xsl:for-each>
  </table>
  <BR />
   <BR d=""/>
</xsl:template>


<xsl:template match="Node">

  <xsl:if test="not(parent::Node)">
     <HR/>
     <BR d=""/>
    <!-- for the top-level node, output a header -->
     <b>
    <FONT size = "+1"> Classification Tree: </FONT>
  </b>
      <BR d=""/>
    <BR d=""/>
  </xsl:if>

    <xsl:if test="Extension/X-VotingTree">    
   <BR d=""/>
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Combination Type : <font color="blue">
		    <xsl:value-of select="Extension/X-VotingTree/@combination_type" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		     Number of Trees : <font color="blue">
		    <xsl:value-of select="Extension/X-VotingTree/@number_of_trees" />
		    </font>
		                                         
	     </b>
			    
                </LI>
            </UL>
    <BR d=""/>
        <ol>
           
            <xsl:for-each select="child::Node">
                 <li>
                 <xsl:apply-templates select="."/>
                 <br/>
                 </li>
           </xsl:for-each>     
        </ol>    
    </xsl:if>
    
    <xsl:if test="not(Extension/X-VotingTree)">    


  <!-- this recursive template processes each node, and then
       processes any child nodes, to preserve the tree structure 

  <xsl:if test="not(parent::Node)">
     <HR/>
     <BR d=""/>
     <b>
    <FONT size = "+1"> Classification Tree </FONT>
  </b>
      <BR d=""/>
    <BR d=""/>
SIMPLE TREE
  </xsl:if> -->
    
  
<!-- this div makes sure the nested rules are indented in the output --> 
<DIV style="margin-left:10px" >
    <!-- this part prints the rule -->

  <xsl:choose>

    <xsl:when test="True">    
      True -->  <b><font color="blue"><xsl:value-of select="@score"/></font></b>
      (<b><xsl:value-of select="@recordCount"/></b>
        <xsl:text>)</xsl:text>
    </xsl:when> 
 
    <xsl:when test="CompoundPredicate/SimplePredicate">    
      <xsl:value-of select="CompoundPredicate/SimplePredicate/@field"/>
    </xsl:when>
    
    <xsl:when test="SimplePredicate">    
      <xsl:value-of select="SimplePredicate/@field"/>
    </xsl:when>
    
    <xsl:when test="CompoundPredicate/SimpleSetPredicate">    
      <xsl:value-of select="CompoundPredicate/SimpleSetPredicate/@field"/>
    </xsl:when>
  
  </xsl:choose>
    
    <xsl:choose>

      <xsl:when test="CompoundPredicate/SimplePredicate/@operator = 'lessOrEqual'">
        <xsl:text> &lt;= </xsl:text>
      </xsl:when>
      <xsl:when test="SimplePredicate/@operator = 'lessOrEqual'">
        <xsl:text> &lt;= </xsl:text>
      </xsl:when>
      <xsl:when test="CompoundPredicate/SimpleSetPredicate/@operator = 'lessOrEqual'">
        <xsl:text> &lt;= </xsl:text>
      </xsl:when>
      
      <xsl:when test="CompoundPredicate/SimplePredicate/@operator = 'lessThan'">
        <xsl:text> &lt; </xsl:text>
      </xsl:when>
       <xsl:when test="SimplePredicate/@operator = 'lessThan'">
        <xsl:text> &lt; </xsl:text>
      </xsl:when>
      <xsl:when test="CompoundPredicate/SimpleSetPredicate/@operator = 'lessThan'">
        <xsl:text> &lt; </xsl:text>
      </xsl:when>     
      
      <xsl:when test="CompoundPredicate/SimplePredicate/@operator = 'greaterThan'">
        <xsl:text> &gt; </xsl:text>
      </xsl:when>
      <xsl:when test="SimplePredicate/@operator = 'greaterThan'">
        <xsl:text> &gt; </xsl:text>
      </xsl:when>
      <xsl:when test="CompoundPredicate/SimpleSetPredicate/@operator = 'greaterThan'">
        <xsl:text> &gt; </xsl:text>
      </xsl:when>
      
      <xsl:when test="CompoundPredicate/SimplePredicate/@operator = 'greaterOrEqual'">
        <xsl:text> &gt;= </xsl:text>
      </xsl:when>
      <xsl:when test="SimplePredicate/@operator = 'greaterOrEqual'">
        <xsl:text> &gt;= </xsl:text>
      </xsl:when>
      <xsl:when test="CompoundPredicate/SimpleSetPredicate/@operator = 'greaterOrEqual'">
        <xsl:text> &gt;= </xsl:text>
      </xsl:when>
      
      <xsl:when test="CompoundPredicate/SimplePredicate/@operator = 'equal'">
        <xsl:text> = </xsl:text>
      </xsl:when>
      <xsl:when test="SimplePredicate/@operator = 'equal'">
        <xsl:text> = </xsl:text>
      </xsl:when>
      <xsl:when test="CompoundPredicate/SimpleSetPredicate/@operator = 'equal'">
        <xsl:text> = </xsl:text>
      </xsl:when>
      
    </xsl:choose>
    
    
    <xsl:choose>
   
      <xsl:when test="CompoundPredicate/SimplePredicate">    
        
        <xsl:value-of select="CompoundPredicate/SimplePredicate/@value"/>
        <xsl:text> -> </xsl:text>
        <!-- this part prints the predicted value and instances -->
        <b><font color="blue"><xsl:value-of select="@score"/></font></b>
        <xsl:text> (</xsl:text>
        <b><xsl:value-of select="@recordCount"/></b>
        <xsl:text>)</xsl:text>
        
      </xsl:when>
      
      <xsl:when test="SimplePredicate">    
        
        <xsl:value-of select="SimplePredicate/@value"/>
        <xsl:text> -> </xsl:text>
        <!-- this part prints the predicted value and instances -->
        <b><font color="blue"><xsl:value-of select="@score"/></font></b>
        <xsl:text> (</xsl:text>
        <b><xsl:value-of select="@recordCount"/></b>
        <xsl:text>)</xsl:text>
        
      </xsl:when>
      
      <xsl:when test="CompoundPredicate/SimpleSetPredicate">
          
        <xsl:value-of select="CompoundPredicate/SimpleSetPredicate/@value"/>
        <xsl:text> -> </xsl:text>
        <!-- this part prints the predicted value and instances -->
        <b><font color="blue"><xsl:value-of select="@score"/></font></b>
        <xsl:text> (</xsl:text>
        <b><xsl:value-of select="@recordCount"/></b>
        <xsl:text>)</xsl:text>
      
      </xsl:when>

    </xsl:choose>

    <xsl:choose>
    <xsl:when test="child::Node[CompoundPredicate/SimplePredicate]">    
    <!-- finally, push any child Nodes for processing
         but only push Nodes that contain a SimplePredicate -->
    <xsl:apply-templates select="child::Node[CompoundPredicate/SimplePredicate]"/>
    </xsl:when>
    </xsl:choose>
    
    <xsl:choose>
    <xsl:when test="child::Node[SimplePredicate]">    
    <!-- finally, push any child Nodes for processing
         but only push Nodes that contain a SimplePredicate -->
    <xsl:apply-templates select="child::Node[SimplePredicate]"/>
    </xsl:when>
    </xsl:choose>
    
    <xsl:choose>
    <xsl:when test="child::Node[CompoundPredicate/SimpleSetPredicate]">    
    <!-- finally, push any child Nodes for processing
         but only push Nodes that contain a SimplePredicate -->
    <xsl:apply-templates select="child::Node[CompoundPredicate/SimpleSetPredicate]"/>
    </xsl:when>
    </xsl:choose>
    
  </DIV>
  </xsl:if>
</xsl:template>



<xsl:template match="X-ConfusionMatrixTraining">
     <BR d=""/>  
  <HR/>
     <BR d=""/>
    <!-- for the top-level node, output a header -->
     <b>
    <FONT size = "+1"> Confusion Matrix(es)  [on the rows --> actual values; on the columns --> predicted values]</FONT>
  </b>
   <BR d=""/><BR d=""/>     
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Total training instances : <font color="blue">
		    <xsl:value-of select="@x-totalInst" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Incorrectly training instances (%) : <font color="blue">
		    <xsl:value-of select="@x-incorrectlyInst" /> (<xsl:value-of select="@x-incorrectlyInstPerc" />%)
		    </font>
		                                         
	     </b>
			    
                </LI>
            </UL>
       <BR d=""/>
  <table width="50%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Training Confusion Matrix </th>
    </tr>
                <tr>
                <xsl:call-template name="write-array-string">
                     <xsl:with-param name="string" select="/PMML/TreeModel/Extension/X-ConfusionMatrixTraining/Array/."/>
                </xsl:call-template>				
                </tr>
    <xsl:for-each select="/PMML/TreeModel/Extension/X-ConfusionMatrixTraining/Matrix/Array">
                <tr>
                <xsl:call-template name="write-array-num">
                     <xsl:with-param name="string" select="."/>
                </xsl:call-template>
                </tr>
     </xsl:for-each>
  </table>
</xsl:template>


<xsl:template match="X-ConfusionMatrixTest">
    <BR d=""/>
     <BR d=""/>
        	<UL>
        	<LI>
        	        		    
	    <b>
		    Total test instances : <font color="blue">
		    <xsl:value-of select="@x-totalInst" />
		    </font>
                                         
	    </b>
	    
                </LI>
                <LI>
		        	        		    
	     <b>
		    Incorrectly test instances (%) : <font color="blue">
		    <xsl:value-of select="@x-incorrectlyInst" /> (<xsl:value-of select="@x-incorrectlyInstPerc" />%)
		    </font>
		                                         
	     </b>
			    
                </LI>
            </UL>
       <BR d=""/>
  <table width="50%" border="1">
    <tr>  
    <th colspan="12" bgcolor="#FF9933"> Test Confusion Matrix </th>
    </tr>
                <tr>
                <xsl:call-template name="write-array-string">
                     <xsl:with-param name="string" select="/PMML/TreeModel/Extension/X-ConfusionMatrixTest/Array/."/>
                </xsl:call-template>				
                </tr>
    <xsl:for-each select="/PMML/TreeModel/Extension/X-ConfusionMatrixTest/Matrix/Array">
                <tr>
                <xsl:call-template name="write-array-num">
                     <xsl:with-param name="string" select="."/>
                </xsl:call-template>
                </tr>
     </xsl:for-each>
  </table>
</xsl:template>


<!-- This allows us the read the 'Array' tag, which contains spaces within a single tag value -->

<xsl:template name="write-array-string">
  <xsl:param name="string"/>
  <xsl:choose>
    <xsl:when test="contains($string,' ')">
      <!-- there are still spaces, so write the first token, a new line, and then
             call the template again with the remaining string -->
      <th align="center" bgcolor="#FFCC66">
      <xsl:value-of select="substring-before($string, ' ')"/>
      </th>
      <!-- call the template with the remainder of the string -->
      <xsl:call-template name="write-array-string">
          <xsl:with-param name="string" select="substring-after($string,' ')"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
       <!-- no more spaces, so just write the last token and quit -->
       <th align="center" bgcolor="#FFCC66">
       <xsl:value-of select="$string"/>
       </th>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>


<xsl:template name="write-array-num">
  <xsl:param name="string"/>
  <xsl:choose>
    <xsl:when test="contains($string,' ')">
      <!-- there are still spaces, so write the first token, a new line, and then
             call the template again with the remaining string -->
      <th align="center" bgcolor="#FFFFCC">
      <xsl:value-of select="substring-before($string, ' ')"/>
      </th>
      <!-- call the template with the remainder of the string -->
      <xsl:call-template name="write-array-num">
          <xsl:with-param name="string" select="substring-after($string,' ')"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:otherwise>
       <!-- no more spaces, so just write the last token and quit -->
       <th align="center" bgcolor="#FFFFCC">
       <xsl:value-of select="$string"/>
       </th>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

</xsl:stylesheet>